<%@ include file="/WEB-INF/pages/inc/TagLibs.jsp" %>

<script type="text/javascript">
	function deleteProject(id)
	{
		if (confirm('<bean:message key="project.delete.confirm" bundle="Project"/>'))
		{
			window.location.href = 'project.do?cmd=deleteProject&id=' + id;
		}
	}
	function refresListProject()
	{
		window.location.href = 'project.do?cmd=listProject&filterP=yes';
	}
</script>

<c:choose>
	<c:when test="${ sucess == 'deleteProject' }">
		<div class="ok-form">
			<bean:message key="project.delete.confirm.ok" bundle="Project"/>
		</div>
	</c:when>
</c:choose>

<c:if test="${ fail != null  }">
	<div class="errors-form">
		<bean:message key="${fail}" bundle="Errors"/>
	</div>	
</c:if>

<c:set var="numProject">${ fn:length(listProject) }
</c:set>

<div class="search">
		<h1>
			<bean:message key="project.projects.title.search" bundle="Project"/>
		</h1>
		<html:form action="/project">
		<table id="search" border="0" width="80%" cellspacing="0" cellpadding="2" style="clear: both;">
			<tr>
				<td width="200">
					<label for="prefix_code"><bean:message key="project.form.prefix_code" bundle="Project"/></label>:
				</td>
				<td>
					<html:text property="filtroPrefix_code" styleId="prefix_code" styleClass="text" size="10" maxlength="10" style="width:150px;"/>
				</td>
				<td width="200">
					<label for="name"><bean:message key="project.form.name" bundle="Project"/></label>:
				</td>
				<td>
					<html:text property="filtroName" styleId="name" styleClass="text" size="20" maxlength="50" style="width:150px;"/>
				</td>
			</tr>
			<tr>
				<td class="no-bdr buttons" colspan="4">
					<input type="submit" class="button first" value="<bean:message key="project.listProject.filter" bundle="Project"/>"/>
					<input type="button" class="button" value="<bean:message key="project.listProject.reset" bundle="Project"/>" style="margin-left: 10px;" 
			   			onclick="$(':input[type=text]').val('');$('.errors').hide();refresListProject();"/>
				</td>
			</tr>
		</table>
		<html:hidden property="cmd" value="listProject"/>
		<html:hidden property="id"/>
		<html:hidden property="filterP" value="yes"/>
		</html:form>
		
</div>
<div class="widget">
	<div class="title">
		<div class="links">
			<a href="project.do?cmd=createProject" class="add">
				<bean:message key="project.createProject" bundle="Project"/>
			</a> 
		</div>
		<h1>
			<bean:message key="project.projects.title" bundle="Project"/>
		</h1>
	</div>
	<div class="content">
		<table  id="data" border="0" width="100%" cellspacing="0" cellpadding="5">
		<tr>
			<th colspan="1" class="left">
				<bean:message key="project.listProject.table.row.1.th.1" bundle="Project"/>
			</th>
			<th colspan="3" class="right">
				<bean:message key="project.listProject.table.row.1.th.2" bundle="Project"/>: <c:out value="${numProject}"/>
			</th>
		</tr>
		<tr>
			<td class="subtitle left br"><bean:message key="project.listProject.table.row.2.th.1" bundle="Project"/></td>
			<td class="subtitle left br"><bean:message key="project.listProject.table.row.2.th.2" bundle="Project"/></td>
			<td class="subtitle br"><bean:message key="project.listProject.table.row.2.th.3" bundle="Project"/></td>
			<td class="subtitle">        <bean:message key="project.listProject.table.row.2.th.4" bundle="Project"/></td>
		</tr>
		<c:forEach var="project" items="${listProject}">
			<tr onmouseover="$(this).addClass('over');" onmouseout="$(this).removeClass('over');">
				<td class="left br">${ project.prefix_code }</td>
				<td class="left br">${ project.name }</td>
				<td style="padding-top: 7px;">
					<nobr>
					<a class="roles" href="project.do?cmd=listRolProject&id=${ project.id}">
						<bean:message key="project.action.listRol" bundle="Project"/>
					</a> | 
					<a class="states" href="project.do?cmd=listStateProject&id=${ project.id}">
						<bean:message key="project.action.listState" bundle="Project"/>
					</a> |
					<a class="workflows" href="project.do?cmd=listWorkFlowProject&id=${ project.id}">
						<bean:message key="project.action.listWorkFLow" bundle="Project"/>
					</a> |
					<a class="users" href="project.do?cmd=listUserRolProject&id=${ project.id}">
						<bean:message key="project.action.listUserRol" bundle="Project"/>
					</a>
					</nobr>
				</td>
				<td style="padding-top: 7px;">
					<nobr>
					<a class="consult" href="project.do?cmd=getProject&id=${ project.id}">
						<bean:message key="project.action.consult" bundle="Project"/>
					</a> | 
					<a class="modify" href="project.do?cmd=getProjectModif&id=${ project.id}">
						<bean:message key="project.action.modify" bundle="Project"/>
					</a> | 
					<a class="delete" href="project.do?cmd=getProjectDelete&id=${ project.id}">
						<bean:message key="project.action.delete" bundle="Project"/>
					</a>
					</nobr>
				</td>
			</tr>
		</c:forEach>
		</table>
	</div>
	<c:if test="${ numProject eq 0  }">
		<c:if test="${ AFProject.prefix_code eq  '' && AFProject.name eq '' }">
			<div class="errors-form" style="margin-top: 20px;"><bean:message key="project.listProject.empty" bundle="Project"/></div>
		</c:if>
		<c:if test="${ !(AFProject.prefix_code eq '') || !(AFProject.name eq '') }">
			<div class="errors-form" style="margin-top: 20px;"><bean:message key="project.listProject.filter.empty" bundle="Project"/></div>
		</c:if>
	</c:if>
</div>