package edu.uoc.integra.business.exceptions;

/**
 * <p>Control de Excepciones producidas en el Sistema</p>
 *  
 * @author Miguel Angel Pineda Cruz
 * @version 1.0 
 */
public class ExceptionControl extends Exception 
{
	//************************************************************//
	// CONSTANTES.                                                //
	//************************************************************//
	/** <p>N&uacute;mero de serie por defecto.</p> */
	private static final long serialVersionUID = 1L;
	
	//Mensajes de Excepciones
	/** <p>Par&aacute;metro sin valor </p> */
	public static final String MSG_AUTH_PARAM_NULL       = "errors.param.null";
	/** <p>Par&aacute;metro sin valor </p> */
	public static final String MSG_USER_PARAM_NULL       = "errors.param.null";
	/** <p>Par&aacute;metro sin valor </p> */
	public static final String MSG_PROJECT_PARAM_NULL    = "errors.param.null";
	/** <p>Contrase&ntilde;a no v&aacute;lida.</p> */
	public static final String MSG_USER_PASSWORD_INVALID = "errors.user.password.invalid";
	/** <p>El usuario esta bloqueado.</p> */
	public static final String MSG_USER_LOCKED           = "errors.user.locked";
	/** <p>El identificador de usuario no es v&aacute;lido.</p> */
	public static final String MSG_USER_ID_INVALID       = "errors.user.login.invalid";
	/** <p>Usuario no registrado".</p> */
	public static final String MSG_USER_NOT_REGISTER     = "errors.user.invalid";
	/** <p>El login de usuario ya esta registrado".</p> */
	public static final String MSG_USER_LOGIN_REGISTER   = "errors.user.login.register";
	/** <p>El email de usaurio ya esta registrado".</p> */
	public static final String MSG_USER_EMAIL_REGISTER   = "errors.user.email.register";
	/** <p>El email de usaurio no esta registrado".</p> */
	public static final String MSG_USER_EMAIL_REGISTER_NOT  = "errors.user.email.register.not";
	/** <p>Usuario Administrador no se puede cambiar la Autorizaci&oacute;n".</p> */
	public static final String MSG_USER_ADMIN_TYPE       = "errors.user.admin.type";
	/** <p>Usuario Administrador no se puede borrar".</p> */
	public static final String MSG_USER_ADMIN_ACTION     = "errors.user.admin.action";
	/** <p>El identificador de configuraci&oacute;n no es v&aacute;lido.</p> */
	public static final String MSG_CONFIG_ID_INVALID     = "errors.config.login.invalid";
	/** <p>No se ha encontrado cargado los par&aacute;metros de configuraci&oacute;n del Sistema </p> */
	public static final String MSG_CONFIGURATION_NOT_LOAD = "errors.config.load";
	/** <p>El identificador de proyecto no es v&aacute;lido.</p> */
	public static final String MSG_PROJECT_ID_INVALID    = "errors.project.invalid";
	/** <p>C&oacute;digo Registro ya se encuentra registrado".</p> */
	public static final String MSG_PROJECT_PREFIX_CODE_REGISTER = "errors.project.prefix.code.register";
	/** <p>Nombre ya se encuentra registrado".</p> */	
	public static final String MSG_PROJECT_NAME_REGISTER  = "errors.project.name.register";
	/** <p>Rol no se encuentra definido en el proyecto".</p> */
	public static final String MSG_PROJECT_ROL_NOT_DEFINE = "errors.project.rol.not.define";
	/** <p>Estado no se encuentra definido en el proyecto".</p> */
	public static final String MSG_PROJECT_STATE_NOT_DEFINE = "errors.project.state.not.define";
	/** <p>Nombre del rol se encuentra registrado".</p> */	
	public static final String MSG_ROL_NAME_REGISTER = "errors.rol.name.register";
	/** <p>Nombre del estado se encuentra registrado".</p> */	
	public static final String MSG_STATE_NAME_REGISTER = "errors.state.name.register";
	/** <p>WorkFlow se encuentra registrado".</p> */
	public static final String MSG_PROJECT_WORKFLOW_EXIST = "errors.workflow.exist";
	/** <p>WorkFlow no se encuentra definido en el proyecto".</p> */
	public static final String MSG_PROJECT_WORKFLOW_NOT_DEFINE = "errors.project.workflow.not.define";
	/** <p>Estado del WorkFlow se encuentra registrado".</p> */
	public static final String MSG_PROJECT_WORKFLOW_STATE_EXIST = "errors.workflow.state.exist";
	/** <p>Usuario-Rol se encuentra registrado en el Proyecto".</p> */
	public static final String MSG_PROJECT_USER_ROL_EXIST = "errors.user.rol.exist";
	/** <p>El identificador de informe no es v&aacute;lido.</p> */
	public static final String MSG_INFORM_ID_INVALID    = "errors.inform.invalid";
	
	
	//************************************************************//	
	// CONSTRUCTORES.                                             //
	//************************************************************//
	/**
	 * <p>Construye un objeto <code>ExceptionControl</code></p>
	 * 
	 * @param msgException <code>String</code> Informaci&oacute;n de la excepci&oacute;n.
	 */
	public ExceptionControl(String msgException)
	{
		super(msgException);
	}

}
