package edu.uoc.integra.business.interfaces;

import edu.uoc.integra.business.exceptions.ExceptionControl;
import edu.uoc.integra.business.objects.transfers.TOArtefact;
import edu.uoc.integra.business.objects.transfers.TOProject;

/**
 * <p>Interfaz que define todas las funcionalidades que est&aacute;n relacionadas
 * con la gesti&oacuten de artefactos en  el sistema. Estas funcionalidades son presentadas a la
 * la capa de presentaci&oacute;n desde la capa de negocio</p>
 * 
 * @author Miguel Angel Pineda Cruz
 * @version 1.0 
 */
public interface IBArtefactManager {
	
/**
 * <p>Este m&eacute;todo es invocado cada vez que un usuario quiera consultar los artefactos
 * definidos en un proyecto.</p>
 * 
 * @param project <code>TOProject</code> informaci&oacute;n del proyecto
 * 
 * @return <code>TOArtefact</code> Informaci&oacute;n del informe completo.
 * 
 */
public abstract TOArtefact listArtefactProject(TOProject project) throws ExceptionControl;
	
	

}
