package edu.uoc.integra.business.objects.transfers;

import java.io.Serializable;
import java.util.List;

public class TOInformR implements Serializable, Comparable<TOInformR>  {

	
	//************************************************************//
	// CONSTANTES.                                                //
	//************************************************************//
	/** <p>N&uacute;mero de serie por defecto.</p> */
	private static final long serialVersionUID = 1L;
	
	
	//************************************************************//
	// ATRIBUTOS.                                                 //
	//************************************************************//
	/** <p>Datos del Proyecto.</p> */
	protected TOProject project;
	/** <p>Roles del Proyecto.</p> */
	protected List<TORol> rols;
	/** <p>Estados del Proyecto.</p> */
	protected List<TOState> states;
	/** <p>WorkFlows del Proyecto.</p> */
	protected List<TOWorkFlow> workflows;
	/** <p>Usuarios-Roles del Proyecto.</p> */
	protected List<TOUserRol> users;
	
	
	//************************************************************//	
	// CONSTRUCTORES.                                             //
	//************************************************************//
	
	/**
	 * <p>Construye un objeto <code>TOInformR</code></p>
	 */
	public TOInformR()
	{
		// Constructor de la superclase.
		super();
	}
	
	
	/**
	 * <p>Construye un objeto <code>TOInformR</code> con la informaci&oacute;n que recibe por par&aacute;metro.</p>
	 *  	
	 * @param project <code>TOProject</code> Datos del Proyecto
	 * 
	 */
	public TOInformR(TOProject project) {
		
		// Constructor de la superclase.
		super();
		
		this.project  = project;
	}

	
	//************************************************************//	
	// GETTERS Y SETTERS.                                         //
	//************************************************************//
	
	// project 
	public TOProject getProject()
	{
		return project;
	}
	public void setProject(TOProject project)
	{
		this.project = project;
	}
	
	// rols 
	public List<TORol> getRols()
	{
		return rols;
	}
	public void setRols(List<TORol> rols)
	{
		this.rols = rols;
	}
	
	// states 
	public List<TOState> getStates()
	{
		return states;
	}
	public void setStates(List<TOState> states)
	{
		this.states = states;
	}
	
	// workflows 
	public List<TOWorkFlow> getWorkFlows()
	{
		return workflows;
	}
	public void setWorkFlows(List<TOWorkFlow> workflows)
	{
		this.workflows = workflows;
	}
	
	// users 
	public List<TOUserRol> getUsers()
	{
		return users;
	}
	public void setUsers(List<TOUserRol> users)
	{
		this.users = users;
	}

	@Override
	public int compareTo(TOInformR o) {
		
		// Comprobamos que el par&aacute;metro no es nulo.
		if (o == null)
		{
			// Si el par&aacute;metro es null vamos a suponer que "this" es mayor.
			return 1;
		}

		// Comprobamos si el atributo "project" tiene el valor "null"
		if (this.project == null)
		{
			// En el caso de que el tipo sea nulo vamos a suponer que "this" es menor.
			return -1;
		}
		
				
		// Comparamos el project 
		return this.project.compareTo(o.getProject());
	}

}
