package edu.uoc.integra.struts.actions;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import edu.uoc.integra.business.exceptions.ExceptionControl;
import edu.uoc.integra.business.interfaces.IBProjectManager;
import edu.uoc.integra.business.interfaces.IBUserManager;
import edu.uoc.integra.business.objects.transfers.TOProject;
import edu.uoc.integra.business.objects.transfers.TORol;
import edu.uoc.integra.business.objects.transfers.TOState;
import edu.uoc.integra.business.objects.transfers.TOUser;
import edu.uoc.integra.business.objects.transfers.TOUserRol;
import edu.uoc.integra.business.objects.transfers.TOWorkFlow;
import edu.uoc.integra.lib.utils.Validations;
import edu.uoc.integra.struts.forms.AFProject;
import edu.uoc.integra.struts.forms.AFProjectRol;
import edu.uoc.integra.struts.forms.AFProjectState;
import edu.uoc.integra.struts.forms.AFProjectUserRol;
import edu.uoc.integra.struts.forms.AFProjectWorkFlow;


/**
 * Esta clase es la encargada de manejar las acciones relacionadas con la gesti&oacute;n de los proyectos de la aplicaci&oacute;n.</p>
 * 
 * @author Miguel Angel Pineda Cruz
 * @version 1.0
 */
public class DAProject extends DACommom 
{
	//Vistas Proyecto
	public static final String VIEW_ADMIN_CREATE_PROJECT  = "?opt=admin&page=ProjectNew";
	public static final String VIEW_ADMIN_LIST_PROJECT    = "?opt=admin&page=ProjectList";
	public static final String VIEW_ADMIN_PROJECT_INFO    = "?opt=admin&page=ProjectInfo";
	public static final String VIEW_ADMIN_PROJECT_MODIF   = "?opt=admin&page=ProjectModif";
	public static final String VIEW_ADMIN_PROJECT_DELETE  = "?opt=admin&page=ProjectDelete";
	
	//Vistas Roles	
	public static final String VIEW_ADMIN_CREATE_ROL      = "?opt=admin&page=RolNew";
	public static final String VIEW_ADMIN_LIST_ROL        = "?opt=admin&page=RolList";
	public static final String VIEW_ADMIN_ROL_INFO        = "?opt=admin&page=RolInfo";
	public static final String VIEW_ADMIN_ROL_MODIF       = "?opt=admin&page=RolModif";
	public static final String VIEW_ADMIN_ROL_DELETE      = "?opt=admin&page=RolDelete";
	
	//Vistas Estados	
	public static final String VIEW_ADMIN_CREATE_STATE      = "?opt=admin&page=StateNew";
	public static final String VIEW_ADMIN_LIST_STATE        = "?opt=admin&page=StateList";
	public static final String VIEW_ADMIN_STATE_INFO        = "?opt=admin&page=StateInfo";
	public static final String VIEW_ADMIN_STATE_MODIF       = "?opt=admin&page=StateModif";
	public static final String VIEW_ADMIN_STATE_DELETE      = "?opt=admin&page=StateDelete";

	//Vistas WorkFlow	
	public static final String VIEW_ADMIN_CREATE_WORKFLOW     = "?opt=admin&page=WorkFlowNew";
	public static final String VIEW_ADMIN_LIST_WORKFLOW       = "?opt=admin&page=WorkFlowList";
	public static final String VIEW_ADMIN_WORKFLOW_MODIF      = "?opt=admin&page=WorkFlowModif";
	public static final String VIEW_ADMIN_WORKFLOW_DELETE     = "?opt=admin&page=WorkFlowDelete";
	public static final String VIEW_ADMIN_CREATE_WORKFLOW_STATE = "?opt=admin&page=WorkFlowStateNew";
	public static final String VIEW_ADMIN_LIST_WORKFLOW_STATE = "?opt=admin&page=WorkFlowStateList";
	
	//Vistas userRol	
	public static final String VIEW_ADMIN_CREATE_USERROL   = "?opt=admin&page=UserRolNew";
	public static final String VIEW_ADMIN_LIST_USERROL     = "?opt=admin&page=UserRolList";
	public static final String VIEW_ADMIN_USERROL_DELETE   = "?opt=admin&page=UserRolDelete";
	
	//Acciones Proyecto
	public static final String ACTION_CREATE_PROJECT      = "createProject";
	public static final String ACTION_UNLOCK_PROJECT      = "unlockProject";
	public static final String ACTION_DELETE_PROJECT      = "deleteProject";
	public static final String ACTION_GET_PROJECT         = "getProject";
	public static final String ACTION_LIST_PROJECT        = "listProject";
	
	//Acciones Roles
	public static final String ACTION_CREATE_ROL          = "createRolProject";
	public static final String ACTION_MODIFY_ROL          = "modifyRolProject";
	public static final String ACTION_DELETE_ROL          = "deleteRolProject";
	public static final String ACTION_GET_ROL             = "getRolProject";
	public static final String ACTION_LIST_ROL            = "listRolProject";

	//Acciones Estados
	public static final String ACTION_CREATE_STATE        = "createStateProject";
	public static final String ACTION_MODIFY_STATE        = "modifyStateProject";
	public static final String ACTION_DELETE_STATE        = "deleteStateProject";
	public static final String ACTION_GET_STATE           = "getStateProject";
	public static final String ACTION_LIST_STATE          = "listStateProject";

	//Acciones WorkFlows
	public static final String ACTION_CREATE_WORKFLOW       = "createWorkFlowProject";
	public static final String ACTION_MODIFY_WORKFLOW       = "modifyWorkFlowProject";
	public static final String ACTION_DELETE_WORKFLOW       = "deleteWorkFlowProject";
	public static final String ACTION_GET_WORKFLOW          = "getWorkFlowProject";
	public static final String ACTION_LIST_WORKFLOW         = "listWorkFlowProject";
	public static final String ACTION_CREATE_WORKFLOW_STATE = "createWorkFlowStateProject";
	public static final String ACTION_DELETE_WORKFLOW_STATE = "deleteWorkFlowStateProject";
	public static final String ACTION_LIST_WORKFLOW_STATE   = "listWorkFlowStateProject";

	//Acciones UserRols
	public static final String ACTION_CREATE_USERROL     = "createUserRolProject";
	public static final String ACTION_DELETE_USERROL     = "deleteUserRolProject";
	public static final String ACTION_GET_USERROL        = "getUserRolProject";
	public static final String ACTION_LIST_USERROL       = "listUserRolProject";

	//Objetos
	public static final String SUCESS 	    = "sucess";
	public static final String FAIL 	    = "fail";
	
	public static final String PROJECT 	    = "project";
	public static final String LIST_PROJECT = "listProject";
	public static final String IDPROJECT    = "idproject";
	
	public static final String ROL 		    = "rol";
	public static final String LIST_ROL		= "listRol";
	
	public static final String STATE	    = "state";
	public static final String LIST_STATE	= "listState";

	public static final String WORKFLOW	     = "workflow";
	public static final String LIST_WORKFLOW = "listWorkFlow";
	public static final String IDWORKFLOW    = "idworkflow";

	public static final String USERROL	     = "userrol";
	public static final String LIST_USERROL  = "listUserRol";
	
	/**
	  * <p>Este M&eacute;todo es llamadado cada vez que se quiera dar de alta a un proyecto en el sistema.</p>
	 * 
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProject <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward createProject(ActionMapping mapping, ActionForm formProject, 
			HttpServletRequest request, HttpServletResponse response)
	{
		
		//Vista actual
		String view_act = " ";
		List<TOProject> listProject= null;
		
		
		try{
		
			// Verificamos que el usuario que inicia la acci&oacute;n es un administrador
			// Verificamos que el formulario recibido es el de un Proyecto
			if (isAdmin(request) 
				&& (formProject instanceof AFProject))
			{
				
				//Instanciamos la clase IBProjectManager para acceder a sus m&eacuote;todos
				IBProjectManager ibProjectManager = createIBProjectManager();

				// Solicitamos la lista de Proyectos Definidos en el Sistema
				listProject = ibProjectManager.listProject();

				// Realizamos un Cast del formulario.
				AFProject afProject = (AFProject) formProject;
				
				// Verificamos si existe definido el par&aacuote;metro sec  
				if (Validations.isEmpty(request.getParameter("sec"))){
					 	
					//Guardamos la lista de los proyectos en la request
					request.setAttribute("listProject",listProject);
								
					// Indicamos que se procede a mostrar el formulario de alta
					request.setAttribute("sec", "create");
						
					// Vista Actual
					view_act = VIEW_ADMIN_CREATE_PROJECT;	
				}
				//Alta de Proyecto
				else{
					
					// Validamos los datos del formulario
					ActionErrors errors = afProject.validateCreateProyect();
					
					// Comprobamos si hay errores
					if (errors.size() > 0)
					{
						// Ha habido errores en los datos, los grabamos
						addErrors(request, errors);
						
						//Guardamos la lista de los proyectos en la request
						request.setAttribute("listProject",listProject);
								
						// Indicamos que se procede a mostrar el formulario de alta
						request.setAttribute("sec", "create");
						
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_PROJECT;

					}
					else 
					{
						//Volcamos la informaci&oacute;n del formulario a un objeto de tipo TOProject
						TOProject toProject = new TOProject(afProject.getPrefix_code()
								, afProject.getName()
								, afProject.getDescript(),afProject.getFecopenDate(),afProject.getFeccloseDate());
						 
						// Obtenemos una instancia de IBProjectManager.
						ibProjectManager = createIBProjectManager();
						
						if(!afProject.getIdP().equals("_nil_")){
							toProject = ibProjectManager.createProjectFrom(toProject, Integer.parseInt(afProject.getIdP()));
						}else{
							// Llamamos al m&eacute;todo que permite crear la cuenta del proyecto.
							toProject = ibProjectManager.createProject(toProject);
						}
							
						// Guardamos la informaci&oacute;n del proyecto en la request.
						request.setAttribute(PROJECT, toProject);

						// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
						request.setAttribute(SUCESS, true);
							
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_PROJECT;
					}
				}
			}
		
		}
		catch (ExceptionControl ec)
		{
			// Proyecto existe
			// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
			request.setAttribute(FAIL, ec.getMessage());
			
			//Guardamos la lista de los proyectos en la request
			request.setAttribute("listProject",listProject);
			
			// Vista Actual
			if (Validations.isEmpty(request.getParameter("sec")))
				view_act = VIEW_ADMIN_LIST_PROJECT;
			else
				view_act = VIEW_ADMIN_CREATE_PROJECT;
			
		}
		catch (Exception ex)
		{
			// Nombre de la Clase
			request.setAttribute("infoClass", "DAProject");
			// Nombre de la excepci&oacute;n
			request.setAttribute("type", ex.getClass().getName());
			// Descripci&oacute;n de la excepci&oacute;n
			request.setAttribute("message", ex.getMessage());
			// Nombre de la Transacci&oacute;n
			request.setAttribute("action", ACTION_CREATE_PROJECT);
			// Escribimos por la salida est&aacute;ndar la Traza.
			ex.printStackTrace();

			// Vista Actual.
			view_act = VIEW_GLOBAL_ERROR;		
		}
		
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un proyecto
	 * registrado en el sistema.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProject <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getProject(ActionMapping mapping, ActionForm formProject,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		//Verificamos que el usuario que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "id" y  es num&eacute;rico.
		// Verificamos que el formulario recibido es de tipo AFProject
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("id"))
			&& (formProject instanceof AFProject)){
			
			try
			{
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("id"));
				
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TOProject toProject = ibProjectManager.getProject(idProject);
				
				//Realizamos el Cast del formulario al tipo AFProject
				AFProject afProject = (AFProject) formProject;
				
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProject.copyProperties(toProject);
				
				// Formateamos el campo Descript				
				afProject.formDescript(100);
				
				view_act = VIEW_ADMIN_PROJECT_INFO;
				
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_PROJECT);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			
		}
		
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un proyecto
	 * registrado en el sistema.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProject <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getProjectModif(ActionMapping mapping, ActionForm formProject,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "id" y  es num&eacute;rico.
		// Verificamos que el formulario recibido es de tipo AFProject
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("id"))
			&& (formProject instanceof AFProject)){
			
			try
			{
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("id"));
				
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TOProject toProject = ibProjectManager.getProject(idProject);
				
				//Realizamos el Cast del formulario al tipo AFProject
				AFProject afProject = (AFProject) formProject;
				
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProject.copyProperties(toProject);
				
				view_act = VIEW_ADMIN_PROJECT_MODIF;
				
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_PROJECT);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			
		}
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un proyecto
	 * registrado en el sistema para confirmar su borrado.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProject <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getProjectDelete(ActionMapping mapping, ActionForm formProject,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "id" y  es num&eacute;rico.
		// Verificamos que el formulario recibido es de tipo AFProject
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("id"))
			&& (formProject instanceof AFProject)){
			
			try
			{
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("id"));
				
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TOProject toProject = ibProjectManager.getProject(idProject);
				
				//Realizamos el Cast del formulario al tipo AFProject
				AFProject afProject = (AFProject) formProject;
				
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProject.copyProperties(toProject);
				
				// Formateamos el campo Descript				
				afProject.formDescript(100);
				
				view_act = VIEW_ADMIN_PROJECT_DELETE;
				
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_PROJECT);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			
		}
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}

	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere modificar los datos de un proyecto
	 * registrado en el sistema.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProject <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward modifyProject(ActionMapping mapping, ActionForm formProject, 
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
						
		//Verificamos  que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que el formulario recibido es de tipo AFProject
		if ((isAdmin(request)) 
			&& (formProject instanceof AFProject))
		{
			try
			{
				// Realizamos un Cast del formulario.
				AFProject afProject = (AFProject) formProject;
				
				// Validamos los datos del formulario
				ActionErrors errors = afProject.validateModifyProject();
				
				// Comprobamos si hay errores
				if (errors.size() > 0)
				{
					// Grabamos los errores de validaci&oacute;n simples.
					addErrors(request, errors);
					
					// Vista Actual
					view_act = VIEW_ADMIN_PROJECT_MODIF;
				}
				else
				{
					// Convertimos el identificador a integer
					int idProject = Integer.parseInt(afProject.getId());
					
					// Instanciamos IBProjectManager
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					// Invocamos al m&eacute;todo que actualiza los datos
					TOProject toProject = ibProjectManager.modifyProject(idProject, 
							afProject.getPrefix_code(), 
							afProject.getName(), 
							afProject.getDescript(),afProject.getFecopenDate(),afProject.getFeccloseDate());
					
					// Guardamos la informaci&oacute;n del proyecto en la request.
					request.setAttribute(PROJECT, toProject);
					
					// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
					request.setAttribute(SUCESS, true);
					
					// Vista Actual
					view_act = VIEW_ADMIN_PROJECT_MODIF;
				}
			
			}
			catch (ExceptionControl ec)
			{
				// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
				request.setAttribute(FAIL, ec.getMessage());
				
				// Vista Actual
				view_act = VIEW_ADMIN_PROJECT_MODIF;
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_PROJECT);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();

				// Vista Actual.
				view_act = VIEW_GLOBAL_ERROR;		
			}
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
			
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere eliminar a un proyecto
	 * del sistema.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProject <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward deleteProject(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
		
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "id" y  es num&eacute;rico.
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("id")))
		{
			try
			{
				
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("id"));
						
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
						
				// Llamamos al m&eacute;todo que permite eliminar a un proyecto del sistema.
				ibProjectManager.deleteProject(idProject);
				
				// Recuperamos de nuevo la informaci&oacute;n de los proyectos actualizados
				List<TOProject> projects  = ibProjectManager.listProject();
					
				// Guardamos la informaci&oacute;n en la request.
				request.setAttribute(LIST_PROJECT, projects);
				
				// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
				request.setAttribute(SUCESS, ACTION_DELETE_PROJECT);

				// Vista Actual.
				view_act = VIEW_ADMIN_LIST_PROJECT;
			}
			catch (ExceptionControl ec)
			{
				// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
				request.setAttribute(FAIL, ec.getMessage());

				// Refrescamos la lista de proyectos
				try
				{
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					// Recuperamos la lista de Usuarios Registrados
					List<TOProject> projects  = ibProjectManager.listProject();
					
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(LIST_PROJECT, projects);
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_PROJECT;	
					
				}
				catch (Exception ex)
				{
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_DELETE_PROJECT);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();

					// Vista Actual.
					view_act = VIEW_GLOBAL_ERROR;		
				}
						
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_DELETE_PROJECT);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();

				// Vista Actual.
				view_act = VIEW_GLOBAL_ERROR;		
				
			}
		}
						
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar todos los proyectos
	 * registrados en el sistema.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProject <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward listProject(ActionMapping mapping, ActionForm formProject, 
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
		
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		if (isAdmin(request))
		{
			
			List<TOProject> projects = null;
			
			try
			{
				
				if (formProject instanceof AFProject){
				
					// Realizamos un Cast del formulario.
					AFProject afProject = (AFProject) formProject;
				
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					if (!Validations.isEmpty(request.getParameter("filterP"))){
						
						if(afProject.getFiltroPrefix_code() != null || afProject.getFiltroName() != null){
							
							// Recuperamos la lista de Proyectos Registrados
							projects  = ibProjectManager.listProject(afProject.getFiltroPrefix_code(), afProject.getFiltroName());
							
							// Ponemos los datos del filtro en session
							request.getSession().setAttribute(SESSION_FILTER_PROJECT,afProject);
							
						}else{
							
							// Eliminamos los datos del filtro en session
							request.getSession().removeAttribute(SESSION_FILTER_PROJECT);
							
							// Recuperamos la lista de Proyectos Registrados
							projects  = ibProjectManager.listProject();
						}
					}else{
						
						Object objAFProject = request.getSession().getAttribute(SESSION_FILTER_PROJECT);
						
						//Existe filtro
						if(objAFProject != null && objAFProject instanceof AFProject){
							
							//Casteamos el filtro
							afProject = (AFProject) objAFProject;
							
							// Recuperamos la lista de Proyectos Registrados
							projects  = ibProjectManager.listProject(afProject.getFiltroPrefix_code(), afProject.getFiltroName());
							
							
						}else{
							
							// Recuperamos la lista de Proyectos Registrados
							projects  = ibProjectManager.listProject();
						}
					}
					
				}else{
					
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					// Recuperamos la lista de Proyectos Registrados
					projects  = ibProjectManager.listProject();
				}
					
				// Guardamos la informaci&oacute;n en la request.
				request.setAttribute(LIST_PROJECT, projects);
				
				// Indicamos cual es la siguiente vista a mostrar.
				view_act = VIEW_ADMIN_LIST_PROJECT;
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_LIST_PROJECT);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			
			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
		
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}


	/**
	  * <p>Este M&eacute;todo es llamadado cada vez que se quiera dar de alta a un rol en un proyecto en el sistema.</p>
	 * 
	 * @param mapping 		 <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request 		 <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward createRolProject(ActionMapping mapping, ActionForm formProjectRol, 
			HttpServletRequest request, HttpServletResponse response)
	{
		
		//Vista actual
		String view_act = " ";
		
		try{
		
			// Verificamos que el usuario que inicia la acci&oacute;n es un administrador
			// Verificamos que el formulario recibido es el de Rol de un Proyecto
			if (isAdmin(request) 
				&& (formProjectRol instanceof AFProjectRol))
			{
				
				// Realizamos un Cast del formulario.
				AFProjectRol afProjectRol = (AFProjectRol) formProjectRol;
				
				// Verificamos si existe definido el par&aacuote;metro sec  
				if (Validations.isEmpty(request.getParameter("sec"))){
					 
					// Convertimos el identificador a integer
					int idProject = Integer.parseInt(request.getParameter("id"));
					
					//Instanciamos la clase IBProjectManager para acceder a sus m&eacuote;todos
					IBProjectManager ibProjectManager = createIBProjectManager();

					// Consultamos los datos del Proyecto
					TOProject toProject = ibProjectManager.getProject(idProject);
					
					// Actualizamos el formulario
					afProjectRol.setIdproject(request.getParameter("id"));
					afProjectRol.setPrefix_code(toProject.getPrefix_code());
					afProjectRol.setNameP(toProject.getName());
					
					// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
					request.setAttribute(IDPROJECT, toProject.getId());	
					
					// Vista Actual
					view_act = VIEW_ADMIN_CREATE_ROL;	
				}
				//Alta de Rol
				else{
					
					// Validamos los datos del formulario
					ActionErrors errors = afProjectRol.validateCreateRol();
					
					// Comprobamos si hay errores
					if (errors.size() > 0)
					{
						// Ha habido errores en los datos, los grabamos
						addErrors(request, errors);
						
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, afProjectRol.getIdproject());	
						
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_ROL;

					}
					else 
					{
						//Volcamos la informaci&oacute;n del formulario a un objeto de tipo TORol
						TORol toRol = new TORol(0, Integer.parseInt(afProjectRol.getIdproject())
								,afProjectRol.getPrefix_code()
								,afProjectRol.getNameP()
								,afProjectRol.getName());
						 
						// Obtenemos una instancia de IBProjectManager.
						IBProjectManager ibProjectManager = createIBProjectManager();
						
						// Llamamos al m&eacute;todo que permite crear un rol en un proyecto.
						toRol = ibProjectManager.createRolProject(toRol);
							
						// Guardamos la informaci&oacute;n del rol en la request.
						request.setAttribute(ROL, toRol);
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, toRol.getIdproject());
						// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
						request.setAttribute(SUCESS, true);
							
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_ROL;
					}
				}
			}
		
		}
		catch (ExceptionControl ec)
		{
			// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
			request.setAttribute(FAIL, ec.getMessage());
			
			// Realizamos un Cast del formulario.
			AFProjectRol afProjectRol = (AFProjectRol) formProjectRol;
			
			// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
			request.setAttribute(IDPROJECT, afProjectRol.getIdproject());
			
			// Vista Actual
			if (Validations.isEmpty(request.getParameter("sec")))
				view_act = VIEW_ADMIN_LIST_ROL;
			else
				view_act = VIEW_ADMIN_CREATE_ROL;
			
		}
		catch (Exception ex)
		{
			// Nombre de la Clase
			request.setAttribute("infoClass", "DAProject");
			// Nombre de la excepci&oacute;n
			request.setAttribute("type", ex.getClass().getName());
			// Descripci&oacute;n de la excepci&oacute;n
			request.setAttribute("message", ex.getMessage());
			// Nombre de la Transacci&oacute;n
			request.setAttribute("action", ACTION_CREATE_ROL);
			// Escribimos por la salida est&aacute;ndar la Traza.
			ex.printStackTrace();

			// Vista Actual.
			view_act = VIEW_GLOBAL_ERROR;		
		}
				
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar todos los roles definidos en un proyecto
	 * registrado en el sistema.</p> 
	 *   
	 * @param mapping        <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request        <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward listRolProject(ActionMapping mapping, ActionForm formProjectRol, 
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
		
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		if (isAdmin(request))
		{
			
			List<TORol> rols = null;
			
			// Verificamos si existe definido el par&aacuote;metro id, en este caso recuperamos los
			//datos del Proyecto
			if (!Validations.isEmpty(request.getParameter("id"))){
				try
				{
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					// Obtenemos los datos del Projecto Registrado
					TOProject project = ibProjectManager.getProject(Integer.parseInt(request.getParameter("id")));
						
					// Recuperamos la lista de Proyectos Registrados
					rols  = ibProjectManager.listRolProject(project);
						
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, project);
					request.setAttribute(LIST_ROL, rols);
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_ROL;
				}
				catch (Exception ex)
				{
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_LIST_ROL);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();
					
					view_act = VIEW_GLOBAL_ERROR;			
				}
			}
			else{
				//NO EJECUTAMOS ACCION AL NO ESTAR PROYECTO REGISTRADO
				view_act = VIEW_ADMIN_LIST_PROJECT;
			}
			
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
		
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un rol 
	 * de un proyecto para confirmar su modificaci&oacute;n.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getRolProjectModif(ActionMapping mapping, ActionForm formProjectRol,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idrol" y  es num&eacute;rico.
		//Verificamos que el formulario recibido es de tipo AFProjectRol
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("idproject"))
			&& Validations.isInteger(request.getParameter("idrol"))
			&& (formProjectRol instanceof AFProjectRol)){
			
			try
			{
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));

				// Convertimos el identificador a integer
				int idRol = Integer.parseInt(request.getParameter("idrol"));
				
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TORol toRol = ibProjectManager.getRolProject(idProject, idRol);
				
				//Realizamos el Cast del formulario al tipo AFProjectRol
				AFProjectRol afProjectRol = (AFProjectRol) formProjectRol;
				
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProjectRol.copyProperties(toRol);
				
				// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
				request.setAttribute(IDPROJECT, afProjectRol.getIdproject());
				
				view_act = VIEW_ADMIN_ROL_MODIF;
				
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_ROL);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			
		}
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}

	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere modificar a un rol de un proyecto</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward modifyRolProject(ActionMapping mapping, ActionForm formProjectRol,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		try{
		
			// Verificamos que el usuario que inicia la acci&oacute;n es un administrador
			// Verificamos que el formulario recibido es el de Rol de un Proyecto
				if (isAdmin(request) 
					&& (formProjectRol instanceof AFProjectRol))
					{
						
						// Realizamos un Cast del formulario.
						AFProjectRol afProjectRol = (AFProjectRol) formProjectRol;
						
						// Validamos los datos del formulario
						ActionErrors errors = afProjectRol.validateModifyRol();
							
						// Comprobamos si hay errores
						if (errors.size() > 0)
						{
							// Ha habido errores en los datos, los grabamos
							addErrors(request, errors);
								
							// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
							request.setAttribute(IDPROJECT, afProjectRol.getIdproject());	
								
							// Vista Actual
							view_act = VIEW_ADMIN_ROL_MODIF;

						}
						else 
						{
								 
							// Obtenemos una instancia de IBProjectManager.
							IBProjectManager ibProjectManager = createIBProjectManager();
								
							// Llamamos al m&eacute;todo que permite modificar un rol en un proyecto.
							TORol toRol = ibProjectManager.modifyRolProject(Integer.parseInt(afProjectRol.getIdproject())
									, Integer.parseInt(afProjectRol.getId())
									, afProjectRol.getName());
									
							// Guardamos la informaci&oacute;n del rol en la request.
							request.setAttribute(ROL, toRol);
							// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
							request.setAttribute(IDPROJECT, toRol.getIdproject());
							// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
							request.setAttribute(SUCESS, true);
									
							// Vista Actual
							view_act = VIEW_ADMIN_ROL_MODIF;
						}
						
					}
				
				}
				catch (ExceptionControl ec)
				{
					// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
					request.setAttribute(FAIL, ec.getMessage());
					
					// Realizamos un Cast del formulario.
					AFProjectRol afProjectRol = (AFProjectRol) formProjectRol;
					
					// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
					request.setAttribute(IDPROJECT, afProjectRol.getIdproject());
					
					// Vista Actual
					view_act = VIEW_ADMIN_ROL_MODIF;
					
				}
				catch (Exception ex)
				{
					
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_MODIFY_ROL);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();

					// Vista Actual.
					view_act = VIEW_GLOBAL_ERROR;		
				}
				
				
				
			 // Obtenemos la vista por defecto.
				ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
					
			 // Retornamos la siguiente vista a mostrar al proyecto.
				return (new ActionForward(next.getPath() + view_act));
	}
	
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un rol 
	 * de un proyecto para confirmar su borrado.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getRolProjectDelete(ActionMapping mapping, ActionForm formProjectRol,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idrol" y  es num&eacute;rico.
		//Verificamos que el formulario recibido es de tipo AFProjectRol
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("idproject"))
			&& Validations.isInteger(request.getParameter("idrol"))
			&& (formProjectRol instanceof AFProjectRol)){
			
			try
			{
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));

				// Convertimos el identificador a integer
				int idRol = Integer.parseInt(request.getParameter("idrol"));
				
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TORol toRol = ibProjectManager.getRolProject(idProject, idRol);
				
				//Realizamos el Cast del formulario al tipo AFProjectRol
				AFProjectRol afProjectRol = (AFProjectRol) formProjectRol;
				
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProjectRol.copyProperties(toRol);
				
				// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
				request.setAttribute(IDPROJECT, afProjectRol.getIdproject());
				
				view_act = VIEW_ADMIN_ROL_DELETE;
				
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_ROL);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			
		}
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere eliminar a un rol de un proyecto</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward deleteRolProject(ActionMapping mapping, ActionForm formProjectRol,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
		
		//Verificamos que el usuario que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "id" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("id"))
			&& Validations.isInteger(request.getParameter("idproject")))
		{
			try
			{
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));
				// Convertimos el identificador a integer
				int idRol = Integer.parseInt(request.getParameter("id"));
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				// Llamamos al m&eacute;todo que permite eliminar a un rol de un proyecto.
				ibProjectManager.deleteRolProject(idProject, idRol);
				
				//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
				TOProject project = ibProjectManager.getProject(idProject);
				
				// Recuperamos de nuevo la informaci&oacute;n de los roles actualizados
				List<TORol> rols  = ibProjectManager.listRolProject(project);
					
				// Guardamos la informaci&oacute;n en la request.
				request.setAttribute(PROJECT, project);
				request.setAttribute(LIST_ROL, rols);
				// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
				request.setAttribute(SUCESS, ACTION_DELETE_ROL);

				// Vista Actual.
				view_act = VIEW_ADMIN_LIST_ROL;
			}
			catch (ExceptionControl ec)
			{
				// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
				request.setAttribute(FAIL, ec.getMessage());

				// Refrescamos la lista de proyectos
				try
				{
					// Convertimos el identificador a integer
					int idProject = Integer.parseInt(request.getParameter("idproject"));
					
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
					TOProject project = ibProjectManager.getProject(idProject);
					
					// Recuperamos la lista de Roles definidos en el Proyecto
					List<TORol> rols  = ibProjectManager.listRolProject(project);
					
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, project);
					request.setAttribute(LIST_ROL, rols);
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_ROL;	
					
				}
				catch (Exception ex)
				{
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_DELETE_ROL);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();

					// Vista Actual.
					view_act = VIEW_GLOBAL_ERROR;		
				}
						
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_DELETE_ROL);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();

				// Vista Actual.
				view_act = VIEW_GLOBAL_ERROR;		
				
			}
		}
						
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	/**
	  * <p>Este M&eacute;todo es llamadado cada vez que se quiera dar de alta a un estado en un proyecto en el sistema.</p>
	 * 
	 * @param mapping 		 <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectState <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request 		 <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward createStateProject(ActionMapping mapping, ActionForm formProjectState, 
			HttpServletRequest request, HttpServletResponse response)
	{
		
		//Vista actual
		String view_act = " ";
		
		try{
		
			// Verificamos que el usuario que inicia la acci&oacute;n es un administrador
			// Verificamos que el formulario recibido es el de Estado de un Proyecto
			if (isAdmin(request) 
				&& (formProjectState instanceof AFProjectState))
			{
				
				// Realizamos un Cast del formulario.
				AFProjectState afProjectState = (AFProjectState) formProjectState;
				
				// Verificamos si existe definido el par&aacuote;metro sec  
				if (Validations.isEmpty(request.getParameter("sec"))){
					 
					// Convertimos el identificador a integer
					int idProject = Integer.parseInt(request.getParameter("id"));
					
					//Instanciamos la clase IBProjectManager para acceder a sus m&eacuote;todos
					IBProjectManager ibProjectManager = createIBProjectManager();

					// Consultamos los datos del Proyecto
					TOProject toProject = ibProjectManager.getProject(idProject);
					
					// Actualizamos el formulario
					afProjectState.setIdproject(request.getParameter("id"));
					afProjectState.setPrefix_code(toProject.getPrefix_code());
					afProjectState.setNameP(toProject.getName());
					
					// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
					request.setAttribute(IDPROJECT, toProject.getId());	
					
					// Vista Actual
					view_act = VIEW_ADMIN_CREATE_STATE;	
				}
				//Alta de Estado
				else{
					
					// Validamos los datos del formulario
					ActionErrors errors = afProjectState.validateCreateState();
					
					// Comprobamos si hay errores
					if (errors.size() > 0)
					{
						// Ha habido errores en los datos, los grabamos
						addErrors(request, errors);
						
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, afProjectState.getIdproject());	
						
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_STATE;

					}
					else 
					{
						//Volcamos la informaci&oacute;n del formulario a un objeto de tipo TOState
						TOState toState = new TOState(0, Integer.parseInt(afProjectState.getIdproject())
								,afProjectState.getPrefix_code()
								,afProjectState.getNameP()
								,afProjectState.getName());
						 
						// Obtenemos una instancia de IBProjectManager.
						IBProjectManager ibProjectManager = createIBProjectManager();
						
						// Llamamos al m&eacute;todo que permite crear un estado en un proyecto.
						toState = ibProjectManager.createStateProject(toState);
							
						// Guardamos la informaci&oacute;n del estado en la request.
						request.setAttribute(STATE, toState);
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, toState.getIdproject());
						// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
						request.setAttribute(SUCESS, true);
							
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_STATE;
					}
				}
			}
		
		}
		catch (ExceptionControl ec)
		{
			// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
			request.setAttribute(FAIL, ec.getMessage());
			
			// Realizamos un Cast del formulario.
			AFProjectState afProjectState = (AFProjectState) formProjectState;
			
			// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
			request.setAttribute(IDPROJECT, afProjectState.getIdproject());
			
			// Vista Actual
			if (Validations.isEmpty(request.getParameter("sec")))
				view_act = VIEW_ADMIN_LIST_STATE;
			else
				view_act = VIEW_ADMIN_CREATE_STATE;
			
		}
		catch (Exception ex)
		{
			
			// Nombre de la Clase
			request.setAttribute("infoClass", "DAProject");
			// Nombre de la excepci&oacute;n
			request.setAttribute("type", ex.getClass().getName());
			// Descripci&oacute;n de la excepci&oacute;n
			request.setAttribute("message", ex.getMessage());
			// Nombre de la Transacci&oacute;n
			request.setAttribute("action", ACTION_CREATE_STATE);
			// Escribimos por la salida est&aacute;ndar la Traza.
			ex.printStackTrace();

			// Vista Actual.
			view_act = VIEW_GLOBAL_ERROR;		
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar todos los estados definidos en un proyecto
	 * registrado en el sistema.</p> 
	 *   
	 * @param mapping        <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectState <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request        <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward listStateProject(ActionMapping mapping, ActionForm formProjectState, 
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
		
		
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		if (isAdmin(request))
		{
			
			List<TOState> states = null;
			
			// Verificamos si existe definido el par&aacuote;metro id, en este caso recuperamos los
			//datos del Proyecto
			if (!Validations.isEmpty(request.getParameter("id"))){
				try
				{
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					// Obtenemos los datos del Projecto Registrado
					TOProject project = ibProjectManager.getProject(Integer.parseInt(request.getParameter("id")));
						
					// Recuperamos la lista de Proyectos Registrados
					states  = ibProjectManager.listStateProject(project);
						
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, project);
					request.setAttribute(LIST_STATE, states);
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_STATE;
				}
				catch (Exception ex)
				{
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_LIST_STATE);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();
					
					view_act = VIEW_GLOBAL_ERROR;			
				}
			}
			else{
				//NO EJECUTAMOS ACCION AL NO ESTAR PROYECTO REGISTRADO
				view_act = VIEW_ADMIN_LIST_PROJECT;
			}
			
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
		
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un estado 
	 * de un proyecto para confirmar su modificaci&oacute;n.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectState <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getStateProjectModif(ActionMapping mapping, ActionForm formProjectState,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idstate" y  es num&eacute;rico.
		//Verificamos que el formulario recibido es de tipo AFProjectState
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("idproject"))
			&& Validations.isInteger(request.getParameter("idstate"))
			&& (formProjectState instanceof AFProjectState)){
			
			try
			{
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));

				// Convertimos el identificador a integer
				int idState = Integer.parseInt(request.getParameter("idstate"));
				
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TOState toState = ibProjectManager.getStateProject(idProject, idState);
				
				//Realizamos el Cast del formulario al tipo AFProjectState
				AFProjectState afProjectState = (AFProjectState) formProjectState;
				
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProjectState.copyProperties(toState);
				
				// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
				request.setAttribute(IDPROJECT, afProjectState.getIdproject());
				
				view_act = VIEW_ADMIN_STATE_MODIF;
				
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_STATE);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			
		}
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}

	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere modificar a un estado de un proyecto</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectState <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward modifyStateProject(ActionMapping mapping, ActionForm formProjectState,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		try{
		
			// Verificamos que el usuario que inicia la acci&oacute;n es un administrador
			// Verificamos que el formulario recibido es el de State de un Proyecto
				if (isAdmin(request) 
					&& (formProjectState instanceof AFProjectState))
					{
						
						// Realizamos un Cast del formulario.
						AFProjectState afProjectState = (AFProjectState) formProjectState;
						
						// Validamos los datos del formulario
						ActionErrors errors = afProjectState.validateModifyState();
							
						// Comprobamos si hay errores
						if (errors.size() > 0)
						{
							// Ha habido errores en los datos, los grabamos
							addErrors(request, errors);
								
							// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
							request.setAttribute(IDPROJECT, afProjectState.getIdproject());	
								
							// Vista Actual
							view_act = VIEW_ADMIN_STATE_MODIF;

						}
						else 
						{
								 
							// Obtenemos una instancia de IBProjectManager.
							IBProjectManager ibProjectManager = createIBProjectManager();
								
							// Llamamos al m&eacute;todo que permite modificar un estado en un proyecto.
							TOState toState = ibProjectManager.modifyStateProject(Integer.parseInt(afProjectState.getIdproject())
									, Integer.parseInt(afProjectState.getId())
									, afProjectState.getName());
									
							// Guardamos la informaci&oacute;n del estado en la request.
							request.setAttribute(STATE, toState);
							// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
							request.setAttribute(IDPROJECT, toState.getIdproject());
							// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
							request.setAttribute(SUCESS, true);
									
							// Vista Actual
							view_act = VIEW_ADMIN_STATE_MODIF;
						}
						
					}
				
				}
				catch (ExceptionControl ec)
				{
					// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
					request.setAttribute(FAIL, ec.getMessage());
					
					// Realizamos un Cast del formulario.
					AFProjectState afProjectState = (AFProjectState) formProjectState;
					
					// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
					request.setAttribute(IDPROJECT, afProjectState.getIdproject());
					
					// Vista Actual
					view_act = VIEW_ADMIN_STATE_MODIF;
					
				}
				catch (Exception ex)
				{
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_MODIFY_STATE);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();

					// Vista Actual.
					view_act = VIEW_GLOBAL_ERROR;		
				}
				
				
				
			 // Obtenemos la vista por defecto.
				ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
					
			 // Retornamos la siguiente vista a mostrar al proyecto.
				return (new ActionForward(next.getPath() + view_act));
	}
	
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un estado 
	 * de un proyecto para confirmar su borrado.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectState <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getStateProjectDelete(ActionMapping mapping, ActionForm formProjectState,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idstate" y  es num&eacute;rico.
		//Verificamos que el formulario recibido es de tipo AFProjectState
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("idproject"))
			&& Validations.isInteger(request.getParameter("idstate"))
			&& (formProjectState instanceof AFProjectState)){
			
			try
			{
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));

				// Convertimos el identificador a integer
				int idState = Integer.parseInt(request.getParameter("idstate"));
				
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TOState toState = ibProjectManager.getStateProject(idProject, idState);
				
				//Realizamos el Cast del formulario al tipo AFProjectState
				AFProjectState afProjectState = (AFProjectState) formProjectState;
				
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProjectState.copyProperties(toState);
				
				// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
				request.setAttribute(IDPROJECT, afProjectState.getIdproject());
				
				view_act = VIEW_ADMIN_STATE_DELETE;
				
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_STATE);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			
		}
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere eliminar a un estado de un proyecto</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectState <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward deleteStateProject(ActionMapping mapping, ActionForm formProjectState,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
		
		//Verificamos que el usuario que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "id" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("id"))
			&& Validations.isInteger(request.getParameter("idproject")))
		{
			try
			{
				
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));
				
				// Convertimos el identificador a integer
				int idState = Integer.parseInt(request.getParameter("id"));
						
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
						
				// Llamamos al m&eacute;todo que permite eliminar a un estado de un proyecto.
				ibProjectManager.deleteStateProject(idProject, idState);
				
				//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
				TOProject project = ibProjectManager.getProject(idProject);
				
				// Recuperamos de nuevo la informaci&oacute;n de los estados actualizados
				List<TOState> states  = ibProjectManager.listStateProject(project);
					
				// Guardamos la informaci&oacute;n en la request.
				request.setAttribute(PROJECT, project);
				request.setAttribute(LIST_STATE, states);
				
				// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
				request.setAttribute(SUCESS, ACTION_DELETE_STATE);

				// Vista Actual.
				view_act = VIEW_ADMIN_LIST_STATE;
			}
			catch (ExceptionControl ec)
			{
				// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
				request.setAttribute(FAIL, ec.getMessage());

				// Refrescamos la lista de proyectos
				try
				{
					
					// Convertimos el identificador a integer
					int idProject = Integer.parseInt(request.getParameter("idproject"));
					
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
					TOProject project = ibProjectManager.getProject(idProject);
					
					// Recuperamos la lista de Estados definidos en el Proyecto
					List<TOState> states  = ibProjectManager.listStateProject(project);
					
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, project);
					request.setAttribute(LIST_STATE, states);
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_STATE;	
					
				}
				catch (Exception ex)
				{
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_DELETE_STATE);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();

					// Vista Actual.
					view_act = VIEW_GLOBAL_ERROR;		
				}
						
			}
			catch (Exception ex)
			{
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_DELETE_STATE);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();

				// Vista Actual.
				view_act = VIEW_GLOBAL_ERROR;		
				
			}
		}
						
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	/**
	 * <p>Este M&eacute;todo es llamadado cada vez que se quiera dar de alta a un WorkFlow
	 * dentro de un proyecto a partir de la informaci&oacute;n recibida por par&aacute;metro.</p>
	 * 
	 * @param mapping 		 <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectWorkflow <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request 		 <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward createWorkFlowProject(ActionMapping mapping, ActionForm formProjectWorkFlow, 
			HttpServletRequest request, HttpServletResponse response)
	{
		
		//Vista actual
		String view_act = " ";
		List<TORol> listRol = null;
		List<TOState> listState = null;
		
		try{
		
			// Verificamos que el usuario que inicia la acci&oacute;n es un administrador
			// Verificamos que el formulario recibido es el de WorkFlow de un Proyecto
			if (isAdmin(request) 
				&& (formProjectWorkFlow instanceof AFProjectWorkFlow))
			{
				
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("id"));
				
				//Instanciamos la clase IBProjectManager para acceder a sus m&eacuote;todos
				IBProjectManager ibProjectManager = createIBProjectManager();

				// Consultamos los datos del Proyecto
				TOProject toProject = ibProjectManager.getProject(idProject);
				
				// Solicitamos los Roles definidos en el Proyecto
				listRol = ibProjectManager.listRolProject(toProject);
				
				// Solicitamos los Usuarios definidos en el Proyecto
				listState = ibProjectManager.listStateProject(toProject);
				
				// Realizamos un Cast del formulario.
				AFProjectWorkFlow afProjectWorkFlow = (AFProjectWorkFlow) formProjectWorkFlow;
				
				// Verificamos si existe definido el par&aacuote;metro sec  
				if (Validations.isEmpty(request.getParameter("sec"))){
									
					// Actualizamos el formulario
					afProjectWorkFlow.setIdproject(request.getParameter("id"));
					afProjectWorkFlow.setPrefix_code(toProject.getPrefix_code());
					afProjectWorkFlow.setNameP(toProject.getName());
				
					//Guardamos la lista de los roles en la request
					request.setAttribute("listRol",listRol);

					//Guardamos la lista de los estados en la request
					request.setAttribute("listState",listState);
					
					// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
					request.setAttribute(IDPROJECT, toProject.getId());	
					
					// Vista Actual
					view_act = VIEW_ADMIN_CREATE_WORKFLOW;	
				}
				//Alta de WorkFlow
				else{
					
					// Validamos los datos del formulario
					ActionErrors errors = afProjectWorkFlow.validateCreateWorkFlow();
					
					// Comprobamos si hay errores
					if (errors.size() > 0)
					{
						// Ha habido errores en los datos, los grabamos
						addErrors(request, errors);

						//Guardamos la lista de los roles en la request
						request.setAttribute("listRol",listRol);

						//Guardamos la lista de los estados en la request
						request.setAttribute("listState",listState);
												
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, afProjectWorkFlow.getIdproject());	
						
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_WORKFLOW;

					}
					else 
					{
						//Volcamos la informaci&oacute;n del formulario a un objeto de tipo TOWorkFlow
						TOWorkFlow toWorkFlow = new TOWorkFlow(0, Integer.parseInt(afProjectWorkFlow.getIdproject())
								, afProjectWorkFlow.getPrefix_code()
								, afProjectWorkFlow.getNameP()
								, Integer.parseInt(afProjectWorkFlow.getIdRol())
								, afProjectWorkFlow.getNameRol()
								, Integer.parseInt(afProjectWorkFlow.getIdState())
								, afProjectWorkFlow.getNameState()); 
						 
						// Obtenemos una instancia de IBProjectManager.
						ibProjectManager = createIBProjectManager();
						
						// Llamamos al m&eacute;todo que permite crear un workflow en un proyecto.
						toWorkFlow = ibProjectManager.createWorkFlowProject(toWorkFlow);
							
						// Guardamos la informaci&oacute;n del estado en la request.
						request.setAttribute(WORKFLOW, toWorkFlow);
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, toWorkFlow.getIdproject());
						// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
						request.setAttribute(SUCESS, true);
							
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_WORKFLOW;
					}
				}
			}
		
		}
		catch (ExceptionControl ec)
		{
			// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
			request.setAttribute(FAIL, ec.getMessage());
			
			// Realizamos un Cast del formulario.
			AFProjectWorkFlow afProjectWorkFlow = (AFProjectWorkFlow) formProjectWorkFlow;
			
			//Guardamos la lista de los roles en la request
			request.setAttribute("listRol",listRol);

			//Guardamos la lista de los estados en la request
			request.setAttribute("listState",listState);
			
			// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
			request.setAttribute(IDPROJECT, afProjectWorkFlow.getIdproject());
			
			// Vista Actual
			if (Validations.isEmpty(request.getParameter("sec")))
				view_act = VIEW_ADMIN_LIST_WORKFLOW;
			else
				view_act = VIEW_ADMIN_CREATE_WORKFLOW;
			
		}
		catch (Exception ex)
		{
			// Nombre de la Clase
			request.setAttribute("infoClass", "DAProject");
			// Nombre de la excepci&oacute;n
			request.setAttribute("type", ex.getClass().getName());
			// Descripci&oacute;n de la excepci&oacute;n
			request.setAttribute("message", ex.getMessage());
			// Nombre de la Transacci&oacute;n
			request.setAttribute("action", ACTION_CREATE_WORKFLOW);
			// Escribimos por la salida est&aacute;ndar la Traza.
			ex.printStackTrace();

			// Vista Actual.
			view_act = VIEW_GLOBAL_ERROR;		
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	/**
	 * <p>Este M&eacute;todo es llamadado cada vez que se quiera dar de alta a un estado en un WorkFlow
	 * dentro de un proyecto a partir de la informaci&oacute;n recibida por par&aacute;metro.</p>
	 * 
	 * @param mapping 		 <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectWorkflow <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request 		 <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward createWorkFlowStateProject(ActionMapping mapping, ActionForm formProjectWorkFlow, 
			HttpServletRequest request, HttpServletResponse response)
	{
		
		//Vista actual
		String view_act = " ";
		List<TOState> listState = null;
		
		try{
		
			// Verificamos que el usuario que inicia la acci&oacute;n es un administrador
			// Verificamos que el formulario recibido es el de WorkFlow de un Proyecto
			if (isAdmin(request) 
				&& (formProjectWorkFlow instanceof AFProjectWorkFlow))
			{
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));

				// Convertimos el identificador a integer
				int idWorkFlow = Integer.parseInt(request.getParameter("id"));
				
				//Instanciamos la clase IBProjectManager para acceder a sus m&eacuote;todos
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				// Consultamos los datos del Proyecto
				TOProject toProject = ibProjectManager.getProject(idProject);
				
				// Consultamos los datos del WorkFlow
				TOWorkFlow toWorkFlow = ibProjectManager.getWorkFlowProject(idProject, idWorkFlow);
				
				// Solicitamos los Estados definidos en el Proyecto
				listState = ibProjectManager.listStateProject(toProject);
				
				// Realizamos un Cast del formulario.
				AFProjectWorkFlow afProjectWorkFlow = (AFProjectWorkFlow) formProjectWorkFlow;
				
				// Verificamos si existe definido el par&aacuote;metro sec  
				if (Validations.isEmpty(request.getParameter("sec"))){

					afProjectWorkFlow.copyProperties(toWorkFlow);
					
					//Guardamos la lista de los estados en la request
					request.setAttribute("listState",listState);

					// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
					request.setAttribute(IDPROJECT, toProject.getId());	
					request.setAttribute(IDWORKFLOW, toWorkFlow.getId());
					
					request.setAttribute("action", "states");
					
					// Vista Actual
					view_act = VIEW_ADMIN_CREATE_WORKFLOW_STATE;	
				}
				//Alta de WorkFlow
				else{
					
					
					// Validamos los datos del formulario
					ActionErrors errors = afProjectWorkFlow.validateCreateWorkFlowState();
					
					// Comprobamos si hay errores
					if (errors.size() > 0)
					{
						// Ha habido errores en los datos, los grabamos
						addErrors(request, errors);
						
						//Guardamos la lista de los estados en la request
						request.setAttribute("listState",listState);
						
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, afProjectWorkFlow.getIdproject());	
						
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_WORKFLOW_STATE;

					}
					else 
					{
						//Volcamos la informaci&oacute;n del formulario a un objeto de tipo TOWorkFlow
						toWorkFlow = new TOWorkFlow(Integer.parseInt(afProjectWorkFlow.getId())
								, Integer.parseInt(afProjectWorkFlow.getIdproject())
								, afProjectWorkFlow.getPrefix_code()
								, afProjectWorkFlow.getNameP()
								, Integer.parseInt(afProjectWorkFlow.getIdRol())
								, afProjectWorkFlow.getNameRol()
								, Integer.parseInt(afProjectWorkFlow.getIdState())
								, afProjectWorkFlow.getNameState()); 
						
						//Volcamos la informaci&oacute;n del formulario a un objeto de tipo TOState
						TOState toState = new TOState(Integer.parseInt(afProjectWorkFlow.getIdStateNext())
								, Integer.parseInt(afProjectWorkFlow.getIdproject())
								, afProjectWorkFlow.getPrefix_code()
								, afProjectWorkFlow.getNameP()
								, afProjectWorkFlow.getNameStateNext());
						 
						// Obtenemos una instancia de IBProjectManager.
						ibProjectManager = createIBProjectManager();
						
						// Llamamos al m&eacute;todo que permite crear un workflow en un proyecto.
						toWorkFlow = ibProjectManager.createWorkFlowStateProject(toWorkFlow, toState);
						
						// Guardamos la informaci&oacute;n del estado en la request.
						request.setAttribute(WORKFLOW, toWorkFlow);
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, toWorkFlow.getIdproject());
						// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
						request.setAttribute(SUCESS, true);
							
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_WORKFLOW_STATE;
					}
				}
			}
		
		}
		catch (ExceptionControl ec)
		{
			// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
			request.setAttribute(FAIL, ec.getMessage());
			
			// Realizamos un Cast del formulario.
			AFProjectWorkFlow afProjectWorkFlow = (AFProjectWorkFlow) formProjectWorkFlow;
			
			//Guardamos la lista de los estados en la request
			request.setAttribute("listState",listState);
			
			// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
			request.setAttribute(IDPROJECT, afProjectWorkFlow.getIdproject());
			
			// Vista Actual
			if (Validations.isEmpty(request.getParameter("sec")))
				view_act = VIEW_ADMIN_LIST_WORKFLOW_STATE;
			else
				view_act = VIEW_ADMIN_CREATE_WORKFLOW_STATE;
			
		}
		catch (Exception ex)
		{
			// Nombre de la Clase
			request.setAttribute("infoClass", "DAProject");
			// Nombre de la excepci&oacute;n
			request.setAttribute("type", ex.getClass().getName());
			// Descripci&oacute;n de la excepci&oacute;n
			request.setAttribute("message", ex.getMessage());
			// Nombre de la Transacci&oacute;n
			request.setAttribute("action", ACTION_CREATE_WORKFLOW_STATE);
			// Escribimos por la salida est&aacute;ndar la Traza.
			ex.printStackTrace();

			// Vista Actual.
			view_act = VIEW_GLOBAL_ERROR;		
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar todos los estados definidos  en un workflow de un proyecto
	 * registrado en el sistema.</p> 
	 *   
	 * @param mapping        <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectWorkFlow <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request        <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward listWorkFlowStateProject(ActionMapping mapping, ActionForm formProjectWorkFlow, 
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		if (isAdmin(request))
		{
			
			List<TOState> states = null;
			
			// Verificamos si existe definido el par&aacuote;metro id, en este caso recuperamos los
			//datos del Workflow
			if (!Validations.isEmpty(request.getParameter("idproject")) &&
				!Validations.isEmpty(request.getParameter("idworkflow"))){
				try
				{
					
					// Convertimos el identificador a integer
					int idProject = Integer.parseInt(request.getParameter("idproject"));

					// Convertimos el identificador a integer
					int idWorkFlow = Integer.parseInt(request.getParameter("idworkflow"));
										
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					TOProject toProject = ibProjectManager.getProject(idProject);
					
					// Obtenemos los datos del WorkFlow Registrado
					TOWorkFlow toWorkFlow = ibProjectManager.getWorkFlowProject(idProject, idWorkFlow);
						
					// Recuperamos la lista de Estados registrados en el workflow
					states  = toWorkFlow.getIdstate_next();
						
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, toProject);
					request.setAttribute(WORKFLOW, toWorkFlow);
					request.setAttribute(LIST_STATE, states);
					
					request.setAttribute(IDPROJECT, toProject.getId());
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_WORKFLOW_STATE;
				}
				catch (Exception ex)
				{
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_LIST_WORKFLOW_STATE);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();
					
					view_act = VIEW_GLOBAL_ERROR;			
				}
			}
			else{
				//NO EJECUTAMOS ACCION AL NO ESTAR PROYECTO REGISTRADO
				view_act = VIEW_ADMIN_LIST_PROJECT;
			}
			
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			System.out.println("NO ES ADMINISTRADOR, LO MANDAMOS A LA PANTALLA PRINCIPAL");
			
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
		
	  //Siguiente Vista
		System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
		
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar todos los workflows definidos en un proyecto
	 * registrado en el sistema.</p> 
	 *   
	 * @param mapping        <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectWorkFlow <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request        <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward listWorkFlowProject(ActionMapping mapping, ActionForm formProjectWorkFlow, 
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		System.out.println("Acci&oacute;n listStateProject");
				
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		if (isAdmin(request))
		{
			
			System.out.println("Usuario Administrador");
			List<TOWorkFlow> workflows = null;
			
			// Verificamos si existe definido el par&aacuote;metro id, en este caso recuperamos los
			//datos del Proyecto
			if (!Validations.isEmpty(request.getParameter("id"))){
				try
				{
					System.out.println("Instanciamos IBProjectManager");
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					System.out.println("invocamos metodo getProject");
					// Obtenemos los datos del Projecto Registrado
					TOProject project = ibProjectManager.getProject(Integer.parseInt(request.getParameter("id")));
						
					System.out.println("invocamos metodo listWorkFlowProject");
					// Recuperamos la lista de WorkFlows registradoes en un Proyecto
					workflows  = ibProjectManager.listWorkFlowProject(project);
						
					System.out.println("Guardamos lista en par&aacute;metro" + LIST_WORKFLOW);
					
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, project);
					request.setAttribute(LIST_WORKFLOW, workflows);
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_WORKFLOW;
				}
				catch (Exception ex)
				{
					System.out.println("listState error no controlado ="+ ex);
					
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_LIST_WORKFLOW);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();
					
					view_act = VIEW_GLOBAL_ERROR;			
				}
			}
			else{
				//NO EJECUTAMOS ACCION AL NO ESTAR PROYECTO REGISTRADO
				System.out.println("NO EXISTE PROYECTO, LO REDIGIRIMOS A LA LISTA DE PROYECTOS");
				view_act = VIEW_ADMIN_LIST_PROJECT;
			}
			
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			System.out.println("NO ES ADMINISTRADOR, LO MANDAMOS A LA PANTALLA PRINCIPAL");
			
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
		
	  //Siguiente Vista
		System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
		
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un workflow 
	 * de un proyecto para confirmar su modificaci&oacute;n.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectWorkflow <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getWorkFlowProjectModif(ActionMapping mapping, ActionForm formProjectWorkFlow,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		System.out.println("Acci&oacute;n getWorkflowProjectModif");
		
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idstate" y  es num&eacute;rico.
		//Verificamos que el formulario recibido es de tipo AFProjectWorkFlow
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("idproject"))
			&& Validations.isInteger(request.getParameter("idworkflow"))
			&& (formProjectWorkFlow instanceof AFProjectWorkFlow)){
			
			try
			{
				System.out.println("Pasamos a Integer el identificador del proyecto");
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));

				System.out.println("Pasamos a Integer el identificador del workflow");
				// Convertimos el identificador a integer
				int idWorkFlow = Integer.parseInt(request.getParameter("idworkflow"));
				
				System.out.println("Instanciamos IBProjectManager");
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				System.out.println("Obtenemos  los datos del Workflow");
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TOWorkFlow toWorkflow = ibProjectManager.getWorkFlowProject(idProject, idWorkFlow);
				
				System.out.println("Casteamos el formulario al tipo AFProjectWorkFlow");
				//Realizamos el Cast del formulario al tipo AFProjectState
				AFProjectWorkFlow afProjectWorkFlow = (AFProjectWorkFlow) formProjectWorkFlow;
				
				System.out.println("Copiamos la informaci&oacute;n al formulario");
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProjectWorkFlow.copyProperties(toWorkflow);
				
				System.out.println("afProjectWorkflow:" + afProjectWorkFlow.getPrefix_code());
				System.out.println("afProjectWorkflow:" + afProjectWorkFlow.getNameP() );
				System.out.println("afProjectWorkflow:" + afProjectWorkFlow.getNameRol());
				System.out.println("afProjectWorkflow:" + afProjectWorkFlow.getNameState());
				
				// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
				request.setAttribute(IDPROJECT, afProjectWorkFlow.getIdproject());
				
				view_act = VIEW_ADMIN_WORKFLOW_MODIF;
				
			}
			catch (Exception ex)
			{
				System.out.println("getWorkFlowProjectModif error no controlado ="+ ex);
				
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_WORKFLOW);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			System.out.println("NO ES ADMINISTRADOR, LO MANDAMOS A LA PANTALLA PRINCIPAL");
			
		}
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		  //Siguiente Vista
			System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}

	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere modificar a un workflow de un proyecto</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectWorkFlow <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward modifyWorkFlowProject(ActionMapping mapping, ActionForm formProjectWorkFlow,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		System.out.println("Acci&oacute;n  getWorkFlowProjectModif");
				
		try{
		
			// Verificamos que el usuario que inicia la acci&oacute;n es un administrador
			// Verificamos que el formulario recibido es el de WorkFlow de un Proyecto
				if (isAdmin(request) 
					&& (formProjectWorkFlow instanceof AFProjectWorkFlow))
					{
						
						System.out.println("Realizamos Cast de los campos del formulario");
						// Realizamos un Cast del formulario.
						AFProjectWorkFlow afProjectWorkFlow = (AFProjectWorkFlow) formProjectWorkFlow;
						
						System.out.println("Realizamos Validaciones de los campos del formulario");
						// Validamos los datos del formulario
						ActionErrors errors = afProjectWorkFlow.validateCreateWorkFlow();
							
						// Comprobamos si hay errores
						if (errors.size() > 0)
						{
							System.out.println("Hemos encontrado Errores");
							// Ha habido errores en los datos, los grabamos
							addErrors(request, errors);
								
							// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
							request.setAttribute(IDPROJECT, afProjectWorkFlow.getIdproject());	
								
							// Vista Actual
							view_act = VIEW_ADMIN_WORKFLOW_MODIF;

						}
						else 
						{
								 
							System.out.println("Instanciamos IBProjectManager");
							// Obtenemos una instancia de IBProjectManager.
							IBProjectManager ibProjectManager = createIBProjectManager();
							
							//Creamos un Objeto TOWorkFlow con los datos del formulario
							System.out.println("Informamos datos del formulario");
							TOWorkFlow toWorkFlow = new TOWorkFlow(Integer.parseInt(afProjectWorkFlow.getId())
									,Integer.parseInt(afProjectWorkFlow.getIdproject())
									,afProjectWorkFlow.getPrefix_code()
									,afProjectWorkFlow.getNameP()
									,Integer.parseInt(afProjectWorkFlow.getIdRol())
									,afProjectWorkFlow.getNameRol()
									,Integer.parseInt(afProjectWorkFlow.getIdState())
									,afProjectWorkFlow.getNameState());
								
							System.out.println("Invocamos al metodo  modifyWorkFlowProject");
							// Llamamos al m&eacute;todo que permite modificar un estado en un proyecto.
							toWorkFlow = ibProjectManager.modifyWorkFlowProject(toWorkFlow);
									
							System.out.println("Informamos el estado modificado");
								
							// Guardamos la informaci&oacute;n del workspace en la request.
							request.setAttribute(WORKFLOW, toWorkFlow);
							// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
							request.setAttribute(IDPROJECT, toWorkFlow.getIdproject());
							// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
							request.setAttribute(SUCESS, true);
									
							// Vista Actual
							view_act = VIEW_ADMIN_WORKFLOW_MODIF;
						}
						
					}
				
				}
				catch (ExceptionControl ec)
				{
					System.out.println("Indicamos que hay un error controlado");
					// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
					request.setAttribute(FAIL, ec.getMessage());
					
					// Realizamos un Cast del formulario.
					AFProjectWorkFlow afProjectWorkFlow = (AFProjectWorkFlow) formProjectWorkFlow;
					
					// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
					request.setAttribute(IDPROJECT, afProjectWorkFlow.getIdproject());
					
					// Vista Actual
					view_act = VIEW_ADMIN_WORKFLOW_MODIF;
					
				}
				catch (Exception ex)
				{
					// Se ha producido cualquier otro tipo de excepci&oacute;n.
					System.out.println("modifyWorkFlowProject error no controlado ="+ ex);
					
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_MODIFY_WORKFLOW);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();

					// Vista Actual.
					view_act = VIEW_GLOBAL_ERROR;		
				}
				
				
				
			 // Obtenemos la vista por defecto.
				ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
					
			 //Siguiente Vista
				System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
					
			 // Retornamos la siguiente vista a mostrar al proyecto.
				return (new ActionForward(next.getPath() + view_act));
	}
	
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un workflow 
	 * de un proyecto para confirmar su borrado.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectWorkFlow <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getWorkFlowProjectDelete(ActionMapping mapping, ActionForm formProjectWorkFlow,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		System.out.println("Acci&oacute;n getWorkFlowProjectDelete");
		
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idworkflow" y  es num&eacute;rico.
		//Verificamos que el formulario recibido es de tipo AFProjectWorkFlow
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("idproject"))
			&& Validations.isInteger(request.getParameter("idworkflow"))
			&& (formProjectWorkFlow instanceof AFProjectWorkFlow)){
			
			try
			{
				System.out.println("Pasamos a Integer el identificador del proyecto");
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));

				System.out.println("Pasamos a Integer el identificador del workflow");
				// Convertimos el identificador a integer
				int idWorkFlow = Integer.parseInt(request.getParameter("idworkflow"));
				
				System.out.println("Instanciamos IBProjectManager");
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				System.out.println("Obtenemos  los datos del WorkFlow");
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TOWorkFlow toWorkFlow = ibProjectManager.getWorkFlowProject(idProject, idWorkFlow);
				
				System.out.println("Casteamos el formulario al tipo AFProjectWorkFlow");
				//Realizamos el Cast del formulario al tipo AFProjectState
				AFProjectWorkFlow afProjectWorkFlow = (AFProjectWorkFlow) formProjectWorkFlow;
				
				System.out.println("Copiamos la informaci&oacute;n al formulario");
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProjectWorkFlow.copyProperties(toWorkFlow);
				
				System.out.println("afProjectWorkflow:" + afProjectWorkFlow.getPrefix_code());
				System.out.println("afProjectWorkflow:" + afProjectWorkFlow.getNameP() );
				System.out.println("afProjectWorkflow:" + afProjectWorkFlow.getNameRol());
				System.out.println("afProjectWorkflow:" + afProjectWorkFlow.getNameState());
				
				// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
				request.setAttribute(IDPROJECT, afProjectWorkFlow.getIdproject());
				
				view_act = VIEW_ADMIN_WORKFLOW_DELETE;
				
			}
			catch (Exception ex)
			{
				System.out.println("getWorkFlowProjectDelete error no controlado ="+ ex);
				
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_WORKFLOW);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			System.out.println("NO ES ADMINISTRADOR, LO MANDAMOS A LA PANTALLA PRINCIPAL");
			
		}
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		  //Siguiente Vista
			System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere eliminar a un estado de un proyecto</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectWorkFlow <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward deleteWorkFlowProject(ActionMapping mapping, ActionForm formProjectWorkFlow,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
		
		System.out.println("Acci&oacute;n deleteWorkFlowProject");
						
		//Verificamos que el usuario que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "id" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("id"))
			&& Validations.isInteger(request.getParameter("idproject")))
		{
			try
			{
				
				System.out.println("Pasamos a Integer el identificador de proyecto");
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));
				
				System.out.println("Pasamos a Integer el identificador de workflow");
				// Convertimos el identificador a integer
				int idWorkFlow = Integer.parseInt(request.getParameter("id"));
						
				System.out.println("Creamos una instancia de ibProjectManager");
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
						
				System.out.println("Invocamos al m&eacute;todo deleteWorkFlow");
				// Llamamos al m&eacute;todo que permite eliminar a un workflow de un proyecto.
				ibProjectManager.deleteWorkFlowProject(idProject, idWorkFlow);
				
				//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
				TOProject project = ibProjectManager.getProject(idProject);
				
				System.out.println("Refrescamos la lista de workflows");
				// Recuperamos de nuevo la informaci&oacute;n de los workflows actualizados
				List<TOWorkFlow> workflows  = ibProjectManager.listWorkFlowProject(project);
					
				System.out.println("Retornamos la lista de proyectos");
				// Guardamos la informaci&oacute;n en la request.
				request.setAttribute(PROJECT, project);
				request.setAttribute(LIST_WORKFLOW, workflows);
				
				System.out.println("Indicamos que la operaci&oacute;n es correcta");
				// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
				request.setAttribute(SUCESS, ACTION_DELETE_WORKFLOW);

				// Vista Actual.
				view_act = VIEW_ADMIN_LIST_WORKFLOW;
			}
			catch (ExceptionControl ec)
			{
				System.out.println("Se ha producido una exception");
				// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
				request.setAttribute(FAIL, ec.getMessage());

				// Refrescamos la lista de proyectos
				try
				{
					
					System.out.println("Pasamos a Integer el identificador de proyecto");
					// Convertimos el identificador a integer
					int idProject = Integer.parseInt(request.getParameter("idproject"));
					
					System.out.println("Instanciamos IBProjectManager");
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
					TOProject project = ibProjectManager.getProject(idProject);
					
					System.out.println("invocamos metodo listWorkFlow");
					// Recuperamos la lista de Estados definidos en el Proyecto
					List<TOWorkFlow> workflows  = ibProjectManager.listWorkFlowProject(project);
					
					System.out.println("Guardamos lista en par&aacute;metro" + LIST_WORKFLOW);
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, project);
					request.setAttribute(LIST_WORKFLOW, workflows);
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_WORKFLOW;	
				}
				catch (Exception ex)
				{
					// Se ha producido cualquier otro tipo de excepci&oacute;n.
					System.out.println("listProjectWorkFlow error no controlado ="+ ex);
					
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_DELETE_WORKFLOW);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();

					// Vista Actual.
					view_act = VIEW_GLOBAL_ERROR;		
				}
						
			}
			catch (Exception ex)
			{
				// Se ha producido cualquier otro tipo de excepci&oacute;n.
				System.out.println("listProjectWorkFlow error no controlado ="+ ex);
				
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_DELETE_WORKFLOW);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();

				// Vista Actual.
				view_act = VIEW_GLOBAL_ERROR;		
				
			}
		}
						
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 //Siguiente Vista
		System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}

	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere eliminar a un estado de un workflow</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectWorkFlow <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward deleteWorkFlowStateProject(ActionMapping mapping, ActionForm formProjectWorkFlow,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
		
		System.out.println("Acci&oacute;n deleteWorkFlowStateProject");
						
		//Verificamos que el usuario que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "id" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idworkflow" y  es num&eacute;rico.
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("idstate"))
			&& Validations.isInteger(request.getParameter("idproject"))
			&& Validations.isInteger(request.getParameter("idworkflow")))
		{
			try
			{
				System.out.println("Pasamos a Integer el identificador de idproject");
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));
				
				System.out.println("Pasamos a Integer el identificador de idworkflow");
				// Convertimos el identificador a integer
				int idWorkFlow = Integer.parseInt(request.getParameter("idworkflow"));
				
				System.out.println("Pasamos a Integer el identificador de estado");
				// Convertimos el identificador a integer
				int idState    = Integer.parseInt(request.getParameter("idstate"));
						
				System.out.println("Creamos una instancia de ibProjectManager");
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
						
				System.out.println("Invocamos al m&eacute;todo deleteWorkFlow");
				// Llamamos al m&eacute;todo que permite eliminar a un workflow de un proyecto.
				ibProjectManager.deleteWorkFlowProject(idProject, idWorkFlow, idState);
				
				//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
				TOProject toProject = ibProjectManager.getProject(idProject);
				
				//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un workflow.
				TOWorkFlow toWorkFlow  = ibProjectManager.getWorkFlowProject(idProject, idWorkFlow);
				
				//Actualizamos lista de estados
				List<TOState> states = toWorkFlow.getIdstate_next();
					
				// Guardamos la informaci&oacute;n en la request.
				request.setAttribute(PROJECT, toProject);
				request.setAttribute(WORKFLOW, toWorkFlow);
				request.setAttribute(LIST_STATE, states);
				
				request.setAttribute(IDPROJECT, toProject.getId());
				
				System.out.println("Indicamos que la operaci&oacute;n es correcta");
				// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
				request.setAttribute(SUCESS, ACTION_DELETE_WORKFLOW_STATE);

				// Indicamos cual es la siguiente vista a mostrar.
				view_act = VIEW_ADMIN_LIST_WORKFLOW_STATE;
			}
			catch (ExceptionControl ec)
			{
				System.out.println("Se ha producido una exception");
				// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
				request.setAttribute(FAIL, ec.getMessage());

				// Refrescamos la lista de proyectos
				try
				{
					
					System.out.println("Pasamos a Integer el identificador de proyecto");
					// Convertimos el identificador a integer
					int idProject = Integer.parseInt(request.getParameter("idproject"));
					
					System.out.println("Pasamos a Integer el identificador de idworkflow");
					// Convertimos el identificador a integer
					int idWorkFlow = Integer.parseInt(request.getParameter("idworkflow"));
					
					System.out.println("Creamos una instancia de ibProjectManager");
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
					TOProject toProject = ibProjectManager.getProject(idProject);
					
					//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un workflow.
					TOWorkFlow toWorkFlow  = ibProjectManager.getWorkFlowProject(idProject, idWorkFlow);
					
					//Actualizamos lista de estados
					List<TOState> states = toWorkFlow.getIdstate_next();
						
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, toProject);
					request.setAttribute(WORKFLOW, toWorkFlow);
					request.setAttribute(LIST_STATE, states);
					
					request.setAttribute(IDPROJECT, toProject.getId());
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_WORKFLOW_STATE;	
				}
				catch (Exception ex)
				{
					// Se ha producido cualquier otro tipo de excepci&oacute;n.
					System.out.println("listProjectWorkFlow error no controlado ="+ ex);
					
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_DELETE_WORKFLOW_STATE);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();

					// Vista Actual.
					view_act = VIEW_GLOBAL_ERROR;		
				}
						
			}
			catch (Exception ex)
			{
				// Se ha producido cualquier otro tipo de excepci&oacute;n.
				System.out.println("listProjectWorkFlow error no controlado ="+ ex);
				
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_DELETE_WORKFLOW_STATE);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();

				// Vista Actual.
				view_act = VIEW_GLOBAL_ERROR;		
				
			}
		}
						
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 //Siguiente Vista
		System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}

	
	
	/**
	 * <p>Este M&eacute;todo es llamadado cada vez que se quiera dar de alta a un user-rol
	 * dentro de un proyecto a partir de la informaci&oacute;n recibida por par&aacute;metro.</p>
	 * 
	 * @param mapping 		 <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectUserRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request 		 <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward createUserRolProject(ActionMapping mapping, ActionForm formProjectUserRol, 
			HttpServletRequest request, HttpServletResponse response)
	{
		
		//Vista actual
		String view_act = " ";
		
		List<TOUser> listUser= null;
		List<TORol> listRol  = null;
		
		System.out.println("Acci&oacute;n  createUserRolProject");
		
		try{
		
			// Verificamos que el usuario que inicia la acci&oacute;n es un administrador
			// Verificamos que el formulario recibido es el de UserRol de un Proyecto
			if (isAdmin(request) 
				&& (formProjectUserRol instanceof AFProjectUserRol))
			{
				
				
				System.out.println("Pasamos a Integer el identificador de proyecto");
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("id"));
				
				System.out.println("Instanciamos createIBProjectManager");
				//Instanciamos la clase IBProjectManager para acceder a sus m&eacuote;todos
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				System.out.println("Instanciamos createIBUserManager");
				//Instanciamos la clase IBUserManager para acceder a sus m&eacuote;todos
				IBUserManager ibUserManager = createIBUserManager();

				System.out.println("Recuperamos los Datos del Proyecto");
				// Consultamos los datos del Proyecto
				TOProject toProject = ibProjectManager.getProject(idProject);
				
				System.out.println("Recuperamos los Usuarios Registrados en el Sistema");
				// Solicitamos la lista de Usuarios registrados en el Sistema
				listUser = ibUserManager.listUser();
				
				System.out.println("Recuperamos los Roles Definidos en el Sistema");
				// Solicitamos los Roles definidos en el Proyecto
				listRol = ibProjectManager.listRolProject(toProject);
				
				System.out.println("Realizamos Cast de los campos del formulario");
				// Realizamos un Cast del formulario.
				AFProjectUserRol afProjectUserRol = (AFProjectUserRol) formProjectUserRol;
				
				// Verificamos si existe definido el par&aacuote;metro sec  
				if (Validations.isEmpty(request.getParameter("sec"))){
					
					// Actualizamos el formulario
					System.out.println("Actualizamos el formulario con los Datos del Proyecto");
					afProjectUserRol.setIdproject(request.getParameter("id"));
					afProjectUserRol.setPrefix_code(toProject.getPrefix_code());
					afProjectUserRol.setNameP(toProject.getName());
					
					System.out.println("Guardamos listUser");
					//Guardamos la lista de los usuarios en la request
					request.setAttribute("listUser",listUser);
					
					System.out.println("Guardamos listRol");
					//Guardamos la lista de los roles en la request
					request.setAttribute("listRol",listRol);
					
					// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
					request.setAttribute(IDPROJECT, toProject.getId());	
					
					// Vista Actual
					view_act = VIEW_ADMIN_CREATE_USERROL;	
				}
				//Alta de UserRol
				else{
					
					System.out.println("Realizamos Validaciones de los campos del formulario");
					
					// Validamos los datos del formulario
					ActionErrors errors = afProjectUserRol.validateCreateUserRol();
					
					// Comprobamos si hay errores
					if (errors.size() > 0)
					{
						System.out.println("Hemos encontrado Errores");
						// Ha habido errores en los datos, los grabamos
						addErrors(request, errors);
						
						System.out.println("Guardamos listUser");
						//Guardamos la lista de los usuarios en la request
						request.setAttribute("listUser",listUser);
						
						System.out.println("Guardamos listRol");
						//Guardamos la lista de los roles en la request
						request.setAttribute("listRol",listRol);
						
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, afProjectUserRol.getIdproject());	
						
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_USERROL;
					}
					else 
					{
						System.out.println("Creamos un objeto tipo TOUserRol con la informaci&oacute;n");
						//Volcamos la informaci&oacute;n del formulario a un objeto de tipo TOUserRol
						TOUserRol toUserRol = new TOUserRol(0
								, Integer.parseInt(afProjectUserRol.getIdproject())
								, afProjectUserRol.getPrefix_code()
								, afProjectUserRol.getNameP()
								, Integer.parseInt(afProjectUserRol.getIdUser())
								, afProjectUserRol.getNameUser()
								, Integer.parseInt(afProjectUserRol.getIdRol())
								, afProjectUserRol.getNameRol()); 
						
						System.out.println("Invocamos al metodo  createUserRolProject");
						// Llamamos al m&eacute;todo que permite crear un user-rol en un proyecto.
						toUserRol = ibProjectManager.createUserRolProject(toUserRol);
							
						System.out.println("Informamos el proyecto creado");
						System.out.println("toUserRol.idproject=" + toUserRol.getIdproject());
						
						// Guardamos la informaci&oacute;n del estado en la request.
						request.setAttribute(USERROL, toUserRol);
						// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
						request.setAttribute(IDPROJECT, toUserRol.getIdproject());
						// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
						request.setAttribute(SUCESS, true);
							
						// Vista Actual
						view_act = VIEW_ADMIN_CREATE_USERROL;
					}
				}
			}
		
		}
		catch (ExceptionControl ec)
		{
			System.out.println("Indicamos que hay un error controlado");
			// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
			request.setAttribute(FAIL, ec.getMessage());
			
			// Realizamos un Cast del formulario.
			AFProjectUserRol afProjectUserRol = (AFProjectUserRol) formProjectUserRol;
			
			// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
			request.setAttribute(IDPROJECT, afProjectUserRol.getIdproject());
			
			// Vista Actual
			if (Validations.isEmpty(request.getParameter("sec")))
				view_act = VIEW_ADMIN_LIST_USERROL;
			else{
				
				System.out.println("Guardamos listUser");
				//Guardamos la lista de los usuarios en la request
				request.setAttribute("listUser",listUser);
				
				System.out.println("Guardamos listRol");
				//Guardamos la lista de los roles en la request
				request.setAttribute("listRol",listRol);
				
				view_act = VIEW_ADMIN_CREATE_USERROL;
			}
		}
		catch (Exception ex)
		{
			// Se ha producido cualquier otro tipo de excepci&oacute;n.
			System.out.println("createProjectUserRol error no controlado ="+ ex);
			
			// Nombre de la Clase
			request.setAttribute("infoClass", "DAProject");
			// Nombre de la excepci&oacute;n
			request.setAttribute("type", ex.getClass().getName());
			// Descripci&oacute;n de la excepci&oacute;n
			request.setAttribute("message", ex.getMessage());
			// Nombre de la Transacci&oacute;n
			request.setAttribute("action", ACTION_CREATE_USERROL);
			// Escribimos por la salida est&aacute;ndar la Traza.
			ex.printStackTrace();

			// Vista Actual.
			view_act = VIEW_GLOBAL_ERROR;		
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 //Siguiente Vista
		System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar todos los userRols definidos en un proyecto
	 * registrado en el sistema.</p> 
	 *   
	 * @param mapping        <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectUserRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request        <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response       <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward listUserRolProject(ActionMapping mapping, ActionForm formProjectUserRol, 
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		System.out.println("Acci&oacute;n listUserRolProject");
				
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		if (isAdmin(request))
		{
			
			System.out.println("Usuario Administrador");
			List<TOUserRol> userRols = null;
			
			// Verificamos si existe definido el par&aacuote;metro id, en este caso recuperamos los
			//datos del Proyecto
			if (!Validations.isEmpty(request.getParameter("id"))){
				try
				{
					System.out.println("Instanciamos IBProjectManager");
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					System.out.println("invocamos metodo getProject");
					// Obtenemos los datos del Projecto Registrado
					TOProject project = ibProjectManager.getProject(Integer.parseInt(request.getParameter("id")));
						
					System.out.println("invocamos metodo listUserRolProject");
					// Recuperamos la lista de userRols registrados en un Proyecto
					userRols  = ibProjectManager.listUserRolProject(project);
						
					System.out.println("Guardamos lista en par&aacute;metro" + LIST_USERROL);
					
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, project);
					request.setAttribute(LIST_USERROL, userRols);
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_USERROL;
				}
				catch (Exception ex)
				{
					System.out.println("listState error no controlado ="+ ex);
					
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_LIST_USERROL);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();
					
					view_act = VIEW_GLOBAL_ERROR;			
				}
			}
			else{
				//NO EJECUTAMOS ACCION AL NO ESTAR PROYECTO REGISTRADO
				System.out.println("NO EXISTE PROYECTO, LO REDIGIRIMOS A LA LISTA DE PROYECTOS");
				view_act = VIEW_ADMIN_LIST_PROJECT;
			}
			
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			System.out.println("NO ES ADMINISTRADOR, LO MANDAMOS A LA PANTALLA PRINCIPAL");
			
		}
		
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
		
	  //Siguiente Vista
		System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
		
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}
	
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere consultar los datos de un user-rol 
	 * de un proyecto para confirmar su borrado.</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectUserRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward getUserRolProjectDelete(ActionMapping mapping, ActionForm formProjectUserRol,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
				
		System.out.println("Acci&oacute;n getUserRolProjectDelete");
		
		//Verificamos que el proyecto que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idworkflow" y  es num&eacute;rico.
		//Verificamos que el formulario recibido es de tipo AFProjectUserRol
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("idproject"))
			&& Validations.isInteger(request.getParameter("iduserrol"))
			&& (formProjectUserRol instanceof AFProjectUserRol)){
			
			try
			{
				System.out.println("Pasamos a Integer el identificador del proyecto");
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));

				System.out.println("Pasamos a Integer el identificador del userrol");
				// Convertimos el identificador a integer
				int idUserRol = Integer.parseInt(request.getParameter("iduserrol"));
				
				System.out.println("Instanciamos IBProjectManager");
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
				
				System.out.println("Obtenemos  los datos del UserRol");
				// Invocamos al m&eacute;todo para obtener los datos del Formulario
				TOUserRol toUserRol = ibProjectManager.getUserRolProject(idProject, idUserRol);
				
				System.out.println("Casteamos el formulario al tipo AFProjectUserRol");
				//Realizamos el Cast del formulario al tipo AFProjectUserRol
				AFProjectUserRol afProjectUserRol = (AFProjectUserRol) formProjectUserRol;
				
				System.out.println("Copiamos la informaci&oacute;n al formulario");
				// Copiamos la informaci&oacute;n del proyecto en el formulario.
				afProjectUserRol.copyProperties(toUserRol);
				
				System.out.println("afProjectUserRol:" + afProjectUserRol.getPrefix_code());
				System.out.println("afProjectUserRol:" + afProjectUserRol.getNameP() );
				System.out.println("afProjectUserRol:" + afProjectUserRol.getNameRol());
				System.out.println("afProjectUserRol:" + afProjectUserRol.getNameUser());
				
				// Guardamos la informaci&oacute;n del identificador del proyecto en la request.
				request.setAttribute(IDPROJECT, afProjectUserRol.getIdproject());
				
				view_act = VIEW_ADMIN_USERROL_DELETE;
				
			}
			catch (Exception ex)
			{
				System.out.println("getUserRolProjectDelete error no controlado ="+ ex);
				
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_GET_USERROL);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();
				
				view_act = VIEW_GLOBAL_ERROR;			

			}
		}else{
			
			//NO EJECUTAMOS ACCION AL NO ESTAR AUTORIZADO
			System.out.println("NO ES ADMINISTRADOR, LO MANDAMOS A LA PANTALLA PRINCIPAL");
			
		}
		
		 // Obtenemos la vista por defecto.
			ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
		  //Siguiente Vista
			System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
			
		 // Retornamos la siguiente vista a mostrar al proyecto.
			return (new ActionForward(next.getPath() + view_act));	
	}
	
	/**
	 * <p>Este M&eacute;todo es llamado cada vez que se quiere eliminar a un usuario-rol de un proyecto</p> 
	 *   
	 * @param mapping <code>ActionMapping</code> mapeos de Struts.
	 * @param formProjectUserRol <code>ActionForm</code> formulario asociado a esta acci&oacute;n. 
	 * @param request <code>HttpServletRequest</code> petici&oacute;n.
	 * @param response <code>HttpServletResponse</code> respuesta.
	 * 
	 * @return <code>ActionForward</code> siguiente vista. 
	 */
	public ActionForward deleteUserRolProject(ActionMapping mapping, ActionForm formProjectUserRol,
			HttpServletRequest request, HttpServletResponse response)
	{
		//Vista actual
		String view_act = " ";
		
		System.out.println("Acci&oacute;n deleteUserRolProject");
						
		//Verificamos que el usuario que inicia la acci&oacute;n es un administrador 
		//Verificamos que existe el par&aacute;metro "id" y  es num&eacute;rico.
		//Verificamos que existe el par&aacute;metro "idproject" y  es num&eacute;rico.
		if (isAdmin(request) 
			&& Validations.isInteger(request.getParameter("id"))
			&& Validations.isInteger(request.getParameter("idproject")))
		{
			try
			{
				System.out.println("Pasamos a Integer el identificador de proyecto");
				// Convertimos el identificador a integer
				int idProject = Integer.parseInt(request.getParameter("idproject"));
				
				System.out.println("Pasamos a Integer el identificador de userrol");
				// Convertimos el identificador a integer
				int idUserRol = Integer.parseInt(request.getParameter("id"));
						
				System.out.println("Creamos una instancia de ibProjectManager");
				// Obtenemos una instancia de IBProjectManager.
				IBProjectManager ibProjectManager = createIBProjectManager();
						
				System.out.println("Invocamos al m&eacute;todo deleteUserRol");
				// Llamamos al m&eacute;todo que permite eliminar a un user-rol de un proyecto.
				ibProjectManager.deleteUserRolProject(idProject, idUserRol);
				
				//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
				TOProject project = ibProjectManager.getProject(idProject);
				
				System.out.println("Refrescamos la lista de userRols");
				// Recuperamos de nuevo la informaci&oacute;n de los userrols actualizados
				List<TOUserRol> userRols  = ibProjectManager.listUserRolProject(project);
					
				System.out.println("Retornamos la lista de proyectos");
				// Guardamos la informaci&oacute;n en la request.
				request.setAttribute(PROJECT, project);
				request.setAttribute(LIST_USERROL, userRols);
				
				System.out.println("Indicamos que la operaci&oacute;n es correcta");
				// Indicamos que la operaci&oacute;n ha sido realizada con &eacute;xito.
				request.setAttribute(SUCESS, ACTION_DELETE_USERROL);

				// Vista Actual.
				view_act = VIEW_ADMIN_LIST_USERROL;
			}
			catch (ExceptionControl ec)
			{
				System.out.println("Se ha producido una exception");
				// Indicamos que la operaci&oacute;n no ha sido realizada con &eacute;xito.
				request.setAttribute(FAIL, ec.getMessage());

				// Refrescamos la lista de proyectos
				try
				{
					
					System.out.println("Pasamos a Integer el identificador de proyecto");
					// Convertimos el identificador a integer
					int idProject = Integer.parseInt(request.getParameter("idproject"));
					
					System.out.println("Instanciamos IBProjectManager");
					// Obtenemos una instancia de IBProjectManager.
					IBProjectManager ibProjectManager = createIBProjectManager();
					
					//LLamamos al m&eacute;todo que permite recuperar la informaci&oacute;n de un proyecto.
					TOProject project = ibProjectManager.getProject(idProject);
					
					System.out.println("invocamos metodo listUserRol");
					// Recuperamos la lista de usuarios-roles definidos en el Proyecto
					List<TOUserRol> userRols  = ibProjectManager.listUserRolProject(project);
					
					System.out.println("Guardamos lista en par&aacute;metro" + LIST_USERROL);
					// Guardamos la informaci&oacute;n en la request.
					request.setAttribute(PROJECT, project);
					request.setAttribute(LIST_USERROL, userRols);
					
					// Indicamos cual es la siguiente vista a mostrar.
					view_act = VIEW_ADMIN_LIST_USERROL;	
				}
				catch (Exception ex)
				{
					// Se ha producido cualquier otro tipo de excepci&oacute;n.
					System.out.println("listUserRolProject error no controlado ="+ ex);
					
					// Nombre de la Clase
					request.setAttribute("infoClass", "DAProject");
					// Nombre de la excepci&oacute;n
					request.setAttribute("type", ex.getClass().getName());
					// Descripci&oacute;n de la excepci&oacute;n
					request.setAttribute("message", ex.getMessage());
					// Nombre de la Transacci&oacute;n
					request.setAttribute("action", ACTION_DELETE_USERROL);
					// Escribimos por la salida est&aacute;ndar la Traza.
					ex.printStackTrace();

					// Vista Actual.
					view_act = VIEW_GLOBAL_ERROR;		
				}
						
			}
			catch (Exception ex)
			{
				// Se ha producido cualquier otro tipo de excepci&oacute;n.
				System.out.println("listProjectUserRol error no controlado ="+ ex);
				
				// Nombre de la Clase
				request.setAttribute("infoClass", "DAProject");
				// Nombre de la excepci&oacute;n
				request.setAttribute("type", ex.getClass().getName());
				// Descripci&oacute;n de la excepci&oacute;n
				request.setAttribute("message", ex.getMessage());
				// Nombre de la Transacci&oacute;n
				request.setAttribute("action", ACTION_DELETE_USERROL);
				// Escribimos por la salida est&aacute;ndar la Traza.
				ex.printStackTrace();

				// Vista Actual.
				view_act = VIEW_GLOBAL_ERROR;		
				
			}
		}
						
	 // Obtenemos la vista por defecto.
		ActionForward next = mapping.findForward(VIEW_GLOBAL_INDEX);
			
	 //Siguiente Vista
		System.out.println("Pr&oacute;xima P&aacute;gina ="+ next.getPath() + view_act);
			
	 // Retornamos la siguiente vista a mostrar al proyecto.
		return (new ActionForward(next.getPath() + view_act));
	}	
}